////////////////////////////////////////////////////////////////////////
// keypress.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.keypress")

// <%pre>
#line 1 "keypress.ecpp"


#include <setup.h>
#include <time.h>

#include <vdr/remote.h>

using namespace vdrlive;


// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
};

static tnt::EcppComponentFactoryImpl<_component_> Factory("keypress");

static const char* rawData = "\030\000\000\000-\000\000\000h\000\000\000\206\000\000\000\244\000\000\000\273\000\000"
  "\000<\?xml version=\"1.0\"\?>\n<service>\n<request name=\"keypress\">\n<param name=\"keycode\"></param>\n<param name="
  "\"repeat\"></param>\n</request>\n<response></response>\n</service>\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl)
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

template <typename T>
inline void _tnt_ignore_unused(const T&) { }

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("keypress " << qparam.getUrl());

  tnt::DataChunks _tntChunks(rawData);

  // <%args>
int keycode = qparam.get< int >("keycode", ( kNone));
int repeat = qparam.get< int >("repeat", ( 1));
  // </%args>

#line 16 "keypress.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
  // <%cpp>
#line 18 "keypress.ecpp"

  if (!logged_in && LiveSetup().UseAuth()) {
    cToSvConcat targetUrl("/login.html?redirect=");
    targetUrl.appendUrlEscaped(request.getQuery());
    return reply.redirect(targetUrl.data());
  }
  reply.setContentType("application/xml");
  struct timespec ts_req;
  ts_req.tv_sec = 0;
  ts_req.tv_nsec = 1000000;
  for (int i = 0; i < repeat;) {
    if (cRemote::Put( (eKeys)keycode ) ) ++i;
    else nanosleep(&ts_req, nullptr);  // to switch to the thread processing the keys
  }
  for (int i = 0; i < 100 && cRemote::HasKeys() ;++i) nanosleep(&ts_req, nullptr);  // to allow processing the keys before we return

  reply.out() << _tntChunks[0]; // <\?xml version="1.0"\?>
  reply.out() << _tntChunks[1]; // \n<service>\n<request name="keypress">\n<param name="keycode">
#line 37 "keypress.ecpp"
  reply.sout() << ( keycode );
  reply.out() << _tntChunks[2]; // </param>\n<param name="repeat">
#line 38 "keypress.ecpp"
  reply.sout() << ( repeat );
  reply.out() << _tntChunks[3]; // </param>\n</request>\n<response>
#line 40 "keypress.ecpp"
  reply.sout() << ( "1" );
  reply.out() << _tntChunks[4]; // </response>\n</service>\n
  // <%/cpp>
  return DEFAULT;
}

} // namespace
