////////////////////////////////////////////////////////////////////////
// pageelems.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.pageelems")

// <%pre>
#line 1 "pageelems.ecpp"

#include "../services.h"

#include <livefeatures.h>
#include <setup.h>
#include <timers.h>
#include <tools.h>
#include <epg_events.h>
#include <gen_version_suffix.h>
#include <tntfeatures.h>

using namespace vdrlive;

std::string toString(const std::vector<std::string> &vec) {
  if (vec.size() == 0) return "";
  std::string result;
  for (const std::string &str:vec) {
    if (!result.empty() ) result.append(", ");
    result.append(str);
  }
  return result;
}

std::string toString(const std::vector<cActor> &vec) {
  if (vec.size() == 0) return "";
  std::string result;
  for (const cActor &actor:vec) {
    if (!result.empty() ) result.append(", ");
    result.append(actor.name);
    if (!actor.role.empty() ) {
      result.append(" (");
      result.append(actor.role);
      result.append(")");
    }
  }
  return result;
}
bool getLanguage(std::string &language, const char *env_name) {
  const char *env_language = std::getenv(env_name);
  bool found = env_language && strlen(env_language) >= 2;
  if (found) language.append(env_language, 2);
  return found;
}


// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    class doc_type_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        doc_type_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class create_html_js_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        create_html_js_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class stylesheets_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        stylesheets_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class logo_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        logo_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class hide_element_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        hide_element_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class progressbar_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        progressbar_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class ajax_action_href_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        ajax_action_href_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class imdb_info_href_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        imdb_info_href_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class hls_channel_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        hls_channel_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class hls_recording_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        hls_recording_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class m3u_playlist_channel_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        m3u_playlist_channel_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class m3u_playlist_recording_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        m3u_playlist_recording_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class stream_recording_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        stream_recording_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class event_timer_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        event_timer_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class edit_timer_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        edit_timer_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class ajax_js_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        ajax_js_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class infobox_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        infobox_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class epg_tool_box_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        epg_tool_box_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class epg_tt_box_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        epg_tt_box_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class media_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        media_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class about_tt_box_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        about_tt_box_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    doc_type_type doc_type;
    create_html_js_type create_html_js;
    stylesheets_type stylesheets;
    logo_type logo;
    hide_element_type hide_element;
    progressbar_type progressbar;
    ajax_action_href_type ajax_action_href;
    imdb_info_href_type imdb_info_href;
    hls_channel_type hls_channel;
    hls_recording_type hls_recording;
    m3u_playlist_channel_type m3u_playlist_channel;
    m3u_playlist_recording_type m3u_playlist_recording;
    stream_recording_type stream_recording;
    event_timer_type event_timer;
    edit_timer_type edit_timer;
    ajax_js_type ajax_js;
    infobox_type infobox;
    epg_tool_box_type epg_tool_box;
    epg_tt_box_type epg_tt_box;
    media_type media;
    about_tt_box_type about_tt_box;
};

static tnt::EcppComponentFactoryImpl<_component_> Factory("pageelems");

static const char* rawData = "\200\006\000\000\201\006\000\000\203\006\000\000\361\006\000\000\362\006\000\000\364\006"
  "\000\000p\007\000\000q\007\000\000\335\007\000\000\251\010\000\000\252\010\000\000\254\010\000\000s\t\000\000\215\t"
  "\000\000\226\t\000\000\243\t\000\000\311\t\000\000\360\t\000\000\361\t\000\000\363\t\000\000\015\n\000\000\016\n\000"
  "\000\020\n\000\000\034\n\000\0005\n\000\0009\n\000\000;\n\000\000I\n\000\000Y\n\000\000Z\n\000\000\134\n\000\000_\n"
  "\000\000c\n\000\000e\n\000\000x\n\000\000\177\n\000\000\201\n\000\000\202\n\000\000\215\n\000\000\224\n\000\000\235\n"
  "\000\000\236\n\000\000\240\n\000\000\312\n\000\000\314\n\000\000\357\n\000\000\361\n\000\000\014\013\000\000\025\013"
  "\000\000\035\013\000\000\036\013\000\000 \013\000\000*\013\000\000H\013\000\000V\013\000\000]\013\000\000f\013\000"
  "\000n\013\000\000o\013\000\000q\013\000\000{\013\000\000\225\013\000\000\243\013\000\000\252\013\000\000\263\013\000"
  "\000\273\013\000\000\274\013\000\000\276\013\000\000\310\013\000\000\347\013\000\000\376\013\000\000\005\014\000\000"
  "\016\014\000\000\026\014\000\000\027\014\000\000\031\014\000\000\"\014\000\0007\014\000\000@\014\000\000D\014\000\000"
  "I\014\000\000J\014\000\000K\014\000\000M\014\000\000g\014\000\000h\014\000\000w\014\000\000\200\014\000\000\204\014"
  "\000\000\211\014\000\000\212\014\000\000\214\014\000\000\220\014\000\000\221\014\000\000\264\014\000\000\300\014\000"
  "\000\311\014\000\000\321\014\000\000\322\014\000\000\324\014\000\000\367\014\000\000\003\015\000\000\014\015\000\000"
  "\024\015\000\000\026\015\000\000\030\015\000\000p\017\000\000\210\017\000\000\317\017\000\000\331\017\000\000\373\017"
  "\000\000\005\020\000\000*\020\000\000\023\021\000\000}\021\000\000~\021\000\000\200\021\000\000\375\021\000\000N\023"
  "\000\000n\023\000\000\324\023\000\000\335\023\000\000\346\023\000\000\357\023\000\000\370\023\000\0007\024\000\000@"
  "\024\000\000r\024\000\000\330\024\000\000\004\025\000\000\034\025\000\000\035\025\000\000\037\025\000\000!\025\000"
  "\000\"\025\000\000&\025\000\000'\025\000\000Q\025\000\000]\025\000\000f\025\000\000n\025\000\000p\025\000\000s\025"
  "\000\000t\025\000\000v\025\000\000w\025\000\000\274\025\000\000\371\025\000\000\375\025\000\000\001\026\000\000\022"
  "\026\000\000.\026\000\0000\026\000\0006\026\000\000L\026\000\000N\026\000\000T\026\000\000l\026\000\000o\026\000\000"
  "\237\026\000\000\253\026\000\000\264\026\000\000\274\026\000\000\310\026\000\000\352\026\000\000\355\026\000\000\363"
  "\026\000\000\364\026\000\000\376\026\000\000 \027\000\000#\027\000\000)\027\000\000*\027\000\0004\027\000\000J\027"
  "\000\000M\027\000\000S\027\000\000T\027\000\000^\027\000\000_\027\000\000a\027\000\000\204\027\000\000\306\027\000"
  "\000\347\027\000\000\033\030\000\000 \030\000\000.\030\000\000f\030\000\000j\030\000\000x\030\000\000\257\030\000\000"
  "\264\030\000\000\302\030\000\000\372\030\000\000\377\030\000\000\013\031\000\000 \031\000\000'\031\000\000\234\031"
  "\000\000\003\032\000\000\034\032\000\000\036\032\000\0005\032\000\0007\032\000\000\?\032\000\000f\032\000\000s\032"
  "\000\000\241\032\000\000\302\032\000\000\312\032\000\000\326\032\000\000\327\032\000\000\372\032\000\000\001\033\000"
  "\000/\033\000\000S\033\000\000\200\033\000\000\244\033\000\000\304\033\000\000\341\033\000\000\025\034\000\0009\034"
  "\000\000Q\034\000\000\177\034\000\000\236\034\000\000\266\034\000\000\344\034\000\000\003\035\000\000\035\035\000\000"
  "\036\035\000\000N\035\000\000O\035\000\000p\035\000\000\202\035\000\000\204\035\000\000\220\035\000\000\242\035\000"
  "\000\276\035\000\000\307\035\000\000\316\035\000\000\352\035\000\000\353\035\000\000\362\035\000\000\020\036\000\000"
  "\022\036\000\000\023\036\000\000\024\036\000\0009\036\000\000<\036\000\000C\036\000\000c\036\000\000d\036\000\000g"
  "\036\000\000n\036\000\000\214\036\000\000\215\036\000\000\224\036\000\000\264\036\000\000\265\036\000\000\274\036\000"
  "\000\346\036\000\000\371\036\000\000\377\036\000\000\037\037\000\0004\037\000\000^\037\000\000r\037\000\000\205\037"
  "\000\000\257\037\000\000\303\037\000\000\326\037\000\000\000 \000\000\024 \000\000' \000\0006 \000\000R \000\000Z "
  "\000\000a \000\000} \000\000\204 \000\000\247 \000\000\260 \000\000\267 \000\000\335 \000\000\357 \000\000\372 \000"
  "\000\026!\000\000\031!\000\000 !\000\000<!\000\000D!\000\000K!\000\000g!\000\000l!\000\000s!\000\000\217!\000\000\220"
  "!\000\000\223!\000\000\232!\000\000\233!\000\000\344!\000\000\367!\000\000\010\"\000\000\t\"\000\000'\"\000\0000\""
  "\000\0007\"\000\000U\"\000\000]\"\000\000d\"\000\000e\"\000\000\203\"\000\000\204\"\000\000\213\"\000\000\251\"\000"
  "\000\262\"\000\000\271\"\000\000\272\"\000\000\330\"\000\000\353\"\000\000\025#\000\000)#\000\000<#\000\000j#\000\000"
  "\200#\000\000\225#\000\000\303#\000\000\331#\000\000\356#\000\000\371#\000\000\000$\000\000\014$\000\000\035$\000\000"
  "%$\000\0000$\000\000S$\000\000\203$\000\000\212$\000\000\214$\000\000\264$\000\000\312$\000\000\320$\000\000\342$\000"
  "\000\350$\000\000\361$\000\000\370$\000\000\004%\000\000\026%\000\000\027%\000\000\030%\000\000 %\000\000,%\000\0003%"
  "\000\0004%\000\0006%\000\0008%\000\0009%\000\000<%\000\000>%\000\000\?%\000\000v%\000\000w%\000\000x%\000\000\216%"
  "\000\000\272%\000\000\326%\000\000\330%\000\000W&\000\000\311&\000\000\374&\000\000`'\000\000\315'\000\000n(\000\000"
  "\326(\000\000<)\000\000\247)\000\000#*\000\000V*\000\000\177*\000\000\246*\000\000\317*\000\000\000+\000\000f+\000"
  "\000\211+\000\000\215+\000\000\231+\000\000\233+\000\000\234+\000\000\250+\000\000\252+\000\000\253+\000\000\005,\000"
  "\000y,\000\000\234,\000\000\240,\000\000\254,\000\000\256,\000\000\257,\000\000\273,\000\000\275,\000\000\276,\000"
  "\000\030-\000\000\205-\000\000\250-\000\000\254-\000\000\270-\000\000\272-\000\000\273-\000\000\307-\000\000\311-\000"
  "\000\312-\000\000 .\000\000d.\000\000m1\000\000\2401\000\000\2372\000\000\n\n\n<!DOCTYPE html PUBLIC \"-//W3C//DTD XH"
  "TML 1.0 Strict//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd\">\n\n\n\n<script type=\"text/javascript\" s"
  "rc=\"js/live/createHtml.js\"></script>\n<script type=\"text/javascript\" src=\"js.html\"></script>\n\n<link rel=\"sty"
  "lesheet\" type=\"text/css\" href=\"css/styles.css\"/>\n<link rel=\"stylesheet\" type=\"text/css\" href=\"\"/>\n<link "
  "rel=\"stylesheet\" type=\"text/css\" href=\"css/siteprefs.css\"/>\n<script type=\"text/javascript\" src=\"js/live/hea"
  "der.js\"></script>\n<script type=\"text/javascript\" src=\"js/live/epg_tt_box.js\"></script>\n\n\n\n<!-- start of fix"
  "ed page header -->\n<div id=\"header\" style=\"width: 100%; background-color: inherit\">\n<div id=\"padding\" style="
  "\"display: none\"></div>\n<div id=\"content\">\n<!-- header content follows -->\n<div class=\"page_header\">\n<a href"
  "=\"\">\n<img src=\"\" alt=\"VDR Live!\" class=\"logo\" /></a>\n</div>\n<div style=\"clear: both\"></div>\n\n\n\nstyle"
  "=\"visibility: hidden\"\n\n\n<div class=\"\"><div class=\"__elapsed\" id=\"\" style=\"width: %\"></div></div>\n\n\n\n"
  "<a id=\"\"  href=\"vdr_request/\?param=\"  ><img src=\"\" alt=\"\" /></a> \n\n\n<a href=\"http://www.imdb.com/find\?s"
  "=all&q=\"\n<a href=\"http://www.imdb.com/title/\"\n target=\"_blank\"><img src=\"\" alt=\"\"  /></a> \n\n\n<a class="
  "\"\" href=\"stream.html\?channelid=\"><img class=\"\" src=\"\" alt=\"\"  /></a>\n\n\n\n<a class=\"\" href=\"stream.ht"
  "ml\?recid=\"><img class=\"\" src=\"\" alt=\"\"  /></a>\n\n\n\n<a class=\"\" href=\"playlist.m3u\?channelid=\" downloa"
  "d><img class=\"\" src=\"\" alt=\"\"  /></a>\n\n\n\n<a href=\"\" download><img src=\"\" alt=\"\"  /> </a>\n\n\n\n\n<a "
  "href=\"http://localhost:/.ts\"><img src=\"\" alt=\"\"  /> </a>\n\n\n\n    \n    <a href=\"edit_timer.html\?epgid=\"><"
  "img src=\"\" alt=\"\"  /></a>\n\n\n\n  <a href=\"edit_timer.html\?timerid=\"><img src=\"\" alt=\"\"  /></a>\n\n\n\n\n"
  "  <script type=\"text/javascript\" src=\"js/mootools/mootools.v1.11.js\"></script>\n  <script type=\"text/javascript"
  "\" src=\"js/live/liveajax.js\"></script>\n  <script type=\"text/javascript\" src=\"js/live/infowin.js\"></script>\n  "
  "<script type=\"text/javascript\" src=\"js/live/hinttips.js\"></script>\n  <script type=\"text/javascript\" src=\"js/l"
  "ive/browserwin.js\"></script>\n  <script type=\"text/javascript\" src=\"js/live/pageenhance.js\"></script>\n  <script"
  " type=\"text/javascript\"><!--\n    var liveEnhanced = new PageEnhance({\n        infoWinOptions: {\n          button"
  "img: 'img/transparent.png',\n          loadingMsg: '',\n          errorMsg: ''\n        },\n        notifyStrings: {"
  "\n          successMsg: '<img src=\"\" alt=\"\"> ',\n          errorMsg: '<img src=\"\" alt=\"\"> '\n        }\n     "
  " });\n  --></script>\n  <script type=\"text/javascript\" src=\"js/live/vdr_status.js\"></script>\n  <script type=\"te"
  "xt/javascript\"><!--\n    var InfoBox = new LiveVdrInfo('ibox.xml', 'infobox');\n    window.addEvent('domready', func"
  "tion(){\n      InfoBox.request();\n    });\n    window.addEvent('unload', function(){\n      InfoBox.pageFinished();"
  "\n    });\n  --></script>\n\n\n\n<div id=\"infobox\">\n  <div class=\"statuscontent\">\n    <div class=\"st_header\">"
  "\n      <div id=\"infobox_caption\" class=\"caption\"></div>\n      <div id=\"infobox_timenow\" class=\"now\">--:--</"
  "div>\n    </div>\n    <div class=\"st_content\">\n      <div id=\"infobox_name\" class=\"name\"></div>\n      <div id"
  "=\"infobox_duration\" class=\"duration\">--:--</div>\n    </div>\n    <div class=\"st_controls\">\n      <div class="
  "\"st_update\">\n        <a href=\"javascript:InfoBox.toggleUpdate()\" ><img id=\"statusReloadBtn\" src=\"\" alt=\"\" "
  "/></a>\n      </div>\n      <div id=\"infobox_recording_buttons\" style=\"display: none\">\n        \n        \n     "
  "   \n        \n        \n      </div>\n      <div id=\"infobox_channel_buttons\">\n        \n        \n      </div>\n"
  "      <div class=\"st_pbar\">\n        \n      </div>\n    </div>\n  </div>\n  <div style=\"display: none;\">\n    <s"
  "pan id=\"__infobox_request_err\"></span>\n    <span id=\"__infobox_update_err\"></span>\n  </div>\n</div>\n\n\n\n  \n"
  "    \n  <a href=\"searchresults.html\?searchplain=\"><img src=\"\" alt=\"\"  /></a>\n  \n  \n  \n<img data-src=\"img/"
  "transparent.png\" height=\"10px\" />\n<span id=\"icons-\"></span>\n<script class=\"injectIcons\">\ninjectHdSdIcon(\"i"
  "cons-\", \"\", \"\", \"\")\n</script>\n  <td class=\"action leftcol \"></td>\n    <td class=\"action \"></td>\n      "
  "<td class=\"action \">\n        <a href=\"searchresults.html\?searchplain=\"><img src=\"\" alt=\"\"  /></a>\n      </"
  "td>\n    <td class=\"td-hidden-xs action\">\n      \n    </td>\n    <td class=\"td-hidden-xs action\">\n      \n    <"
  "/td>\n    <td class=\"action \">\n      \n    </td>\n\n\n\n  <div class=\"epg_description\" id=\"\">\n    <div class="
  "\"station\">\n      <div class=\"boxheader\">\n\n<div>\n<div class = \"caption\">\n  <a id=\"_epg_m\"     class = \"a"
  "ctive\"   onclick=\"displayEPG('')\" ></a>\n| <a id=\"_scraper_m\" class = \"inactive\" onclick=\"displayScraper('')"
  "\"></a>\n| <a id=\"_actors_m\"  class = \"inactive\" onclick=\"displayActors('')\" ></a>\n| <a id=\"_artwork_m\" clas"
  "s = \"inactive\" onclick=\"displayArtwork('')\" ></a>\n</div>\n<div class=\"caption\"></div>\n</div>\n               "
  "         </div>\n    </div>\n    <div class=\"epg_content\">\n      <div class=\"epg_tools\">\n        \n      </div>"
  "\n      <div class=\"epg_info\">\n        <div class=\"info\">\n          <div class=\"duration\">\n            <span"
  " title=\"\"></span> / <span title=\"\"></span>\n            <div class=\"progress\"><div></div></div>\n          </di"
  "v>\n          <div class=\"time\">\n              <span class=\"bold\"></span>\n            \n              <div clas"
  "s=\"channel\"></div>\n          </div>\n          <div class=\"title\"></div>\n          <div class=\"short\"></div>"
  "\n          <div class=\"description\" id=_description>\n          <span id = \"_epg_image\" class=\"epg_images\">\n "
  "        <a href=\"/epgimages/\" target=\"_blank\">\n            <img src=\"/epgimages/\" class=\"epg_image\"/>\n     "
  "    </a>\n    <a href=\"/tvscraper/\" target=\"_blank\">\n      <img src=\"/tvscraper/\" class=\"epg_image\"/>\n    <"
  "/a>\n    <a href=\"/tvscraper/\" target=\"_blank\">\n      <img src=\"/tvscraper/\" class=\"epg_image\"/>\n    </a>\n"
  "      <a href=\"/recimages//\" target=\"_blank\">\n        <img src=\"/recimages//\" class=\"epg_image\"/>\n      </a"
  ">\n          </span> \n\n\n<div id = '_scraper' hidden>\n  <div class=\"scraper_list\">         </div>\n  <div class="
  "\"scraper_list\"> </div>\n    <div class=\"scraper_list\"> SE </div>\n    <div class=\"scraper_list\">   </div>\n    "
  "  <div class=\"scraper_list\">  / </div>\n    <div class=\"scraper_list\"> </div>\n      <div class=\"scraper_list\">"
  " </div>\n      <a href=\"https://www.imdb.com/title/\" target=\"_blank\">  </a>\n      <div class=\"scraper_list\"></"
  "div>\n      <table>\n      <tr>\n        <td class=\"cast_role\">  </td>\n        <td>  </td>\n      </tr>\n      <tr"
  ">\n        <td class=\"cast_role\">  </td>\n        <td>  </td>\n      </tr>\n      <tr>\n        <td class=\"cast_ro"
  "le\">  </td>\n        <td>  </td>\n      </tr>\n      </table>\n  <div class=\"scraper_list\">        </div>\n  <div "
  "class=\"scraper_list\">       </div>\n  <div class=\"scraper_list\">         </div>\n  <div class=\"scraper_list\"><a"
  " href =\"\" target=\"_blank\"></a></div>\n  <div class=\"scraper_list\">   </div>\n  <div class=\"scraper_list\">    "
  "    </div>\n  <div class=\"scraper_list\">     </div>\n  <div class=\"scraper_list\">  / </div>\n\n    <div class=\"s"
  "craper_list\">\n      <a href=\"https://www.imdb.com/title/\" target=\"_blank\">  </a>\n    </div>\n\n    <div class="
  "\"scraper_list\">         </div>\n    <div class=\"scraper_list\">        </div>\n\n    <div class=\"scraper_list\"> "
  "</div>\n    <div class=\"scraper_list\">         </div>\n\n    <div class=\"scraper_list\"></div>\n    <table>\n     "
  " <tr>\n        <td class=\"cast_role\">  </td>\n        <td>  </td>\n      </tr>\n        <tr>\n          <td class="
  "\"cast_role\">  </td>\n          <td>  </td>\n        </tr>\n        <tr>\n          <td class=\"cast_role\">  </td>"
  "\n          <td>  </td>\n        </tr>\n  </table>\n</div>\n\n<div id = '_actors' hidden>\n<table>\n      <tr>\n    <"
  "td>\n      <a href=\"/tvscraper/\" target=\"_blank\">\n        <img src=\"/tvscraper/\" alt=\": \" class=\"actor\" />"
  "\n      </a>\n    </td>\n      </tr>\n      <tr></tr>\n    </tr>\n    <tr></tr>\n</table>\n</div>\n\n<div id = '_artw"
  "ork' hidden>\n\n\n\n</div>\n\n<div id = '_epg'>\n \n :\n    : \n        </div>\n      </div>\n    </div>\n  </div>\n<"
  "/div>\n\n\n  <a href=\"/tvscraper/\" target=\"_blank\">\n    <img src=\"/tvscraper/\" class=\"artwork\" />\n  </a>\n"
  "\n\n  <div class=\"epg_description\" id=\"aboutBox\">\n    <div class=\"station\">\n      <div class=\"boxheader\"><d"
  "iv><div class=\"caption\"></div></div></div>\n    </div>\n    <div class=\"epg_content\">\n      <div>\n        <div "
  "class=\"about_head\"><div><div></div></div></div>\n        <div class=\"about_left\">:</div>\n        <div class=\"ab"
  "out_right\">Thomas Keil (Thomas)</div>\n        <div class=\"about_left\">:</div>\n        <div class=\"about_right\""
  ">Sascha Volkenandt (LordJaxom)</div>\n        <div class=\"about_left\">:</div>\n        <div class=\"about_right\">M"
  "arkus Ehrnsperger (MarkusE @ <a href=\"https://www.vdr-portal.de\">VDR Portal</a>)</div>\n        <div class=\"about_"
  "left\">:</div>\n        <div class=\"about_right\">Jasmin Jessich (jasminj)</div>\n        <div class=\"about_left\">"
  ":</div>\n        <div class=\"about_right\">Dieter Hametner (tadi)</div>\n        <div class=\"about_left\">:</div>\n"
  "        <div class=\"about_right\">Christian Wieninger (winni)</div>\n        <div class=\"about_left\">:</div>\n    "
  "    <div class=\"about_right\">Michael Br&uuml;ckner (skiller2k1)</div>\n        <div class=\"about_head\"><div><div>"
  "</div></div></div>\n        <div class=\"about_left\">:</div>\n        <div class=\"about_right\"></div>\n        <di"
  "v class=\"about_left\">:</div>\n        <div class=\"about_right\"></div>\n        <div class=\"about_head\"><div><di"
  "v></div></div></div>\n        <div class=\"about_left\">EPGsearch:</div>\n        <div class=\"about_right\">\n      "
  "    <img align=\"center\" src=\"\"/>\n            : \n            : \n          (<a href=\"https://github.com/vdr-pro"
  "jects/vdr-plugin-epgsearch\" target=\"_blank\"></a>)<br/>\n        </div>\n        <div class=\"about_left\">Streamde"
  "v server:</div>\n        <div class=\"about_right\">\n          <img align=\"center\" src=\"\"/>\n            : \n   "
  "         : \n          (<a href=\"https://github.com/vdr-projects/vdr-plugin-streamdev\" target=\"_blank\"></a>)<br/>"
  "\n        </div>\n        <div class=\"about_left\">tvscraper:</div>\n        <div class=\"about_right\">\n          "
  "<img align=\"center\" src=\"\"/>\n            : \n            : \n          (<a href=\"https://github.com/MarkusEh/vd"
  "r-plugin-tvscraper\" target=\"_blank\"></a>)<br/>\n        </div>\n        <div class=\"about_head\"><div><div></div>"
  "</div></div>\n        <div class=\"about_line\">Movie information provided by <a target=\"_blank\" href=\"https://www"
  ".themoviedb.org/\">TMDB</a>. This product uses the TMDB API but is not endorsed or certified by TMDB.</div>\n        "
  "<div class=\"about_line\">Information provided by TheTVDB.com. Please consider <a target=\"_blank\" href=\"https://u1"
  "0505776.ct.sendgrid.net/ls/click\?upn=xMYYCP13hVd-2BZPpbVcMPHeLXfv-2BPRdIsKm2qSeirIHi7kH9am8IxD-2BavFbeqGqIXIcjH_INgc"
  "0CXRkIvGU-2BJ1W6HLAynNbR0UBoMb2tkpDdezO3QRj-2FQPQAMrtJKVcB0N7eSvbYpjQTDNOQBf2pb94uDgGr0-2BXyXFk7Oyfva30BASYCRLvtRQyi5"
  "eOCAbH8fon7UETlPydobeLA3Recu9OsXol8c7Ng4pDAsH6KsFF8CH7HQoVxivnpKrQW2v4ek7U-2BYlWmH31o9Koke3vq-2FDsQ0P-2BiKLECU3Lgttsn"
  "tUcN8fnUs-3D\">supporting them.</a></div>\n        <div class=\"about_head\"><div><div></div></div></div>\n        <d"
  "iv class=\"about_line\">:<br/>\n          <a target=\"_blank\" href=\"https://github.com/MarkusEh/vdr-plugin-live/iss"
  "ues\">https://github.com/MarkusEh/vdr-plugin-live/issues</a></div>\n        <div class=\"about_head\"><div><div>&nbsp"
  ";</div></div></div>\n      </div>\n    </div>\n  </div>\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl),
    doc_type(*this, "doc_type"),
    create_html_js(*this, "create_html_js"),
    stylesheets(*this, "stylesheets"),
    logo(*this, "logo"),
    hide_element(*this, "hide_element"),
    progressbar(*this, "progressbar"),
    ajax_action_href(*this, "ajax_action_href"),
    imdb_info_href(*this, "imdb_info_href"),
    hls_channel(*this, "hls_channel"),
    hls_recording(*this, "hls_recording"),
    m3u_playlist_channel(*this, "m3u_playlist_channel"),
    m3u_playlist_recording(*this, "m3u_playlist_recording"),
    stream_recording(*this, "stream_recording"),
    event_timer(*this, "event_timer"),
    edit_timer(*this, "edit_timer"),
    ajax_js(*this, "ajax_js"),
    infobox(*this, "infobox"),
    epg_tool_box(*this, "epg_tool_box"),
    epg_tt_box(*this, "epg_tt_box"),
    media(*this, "media"),
    about_tt_box(*this, "about_tt_box")
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

template <typename T>
inline void _tnt_ignore_unused(const T&) { }

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems " << qparam.getUrl());

  tnt::DataChunks _tntChunks(rawData);

#line 47 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
  reply.out() << _tntChunks[0]; // \n
  reply.out() << _tntChunks[1]; // \n\n
  reply.out() << _tntChunks[3]; // \n
  reply.out() << _tntChunks[4]; // \n\n
  reply.out() << _tntChunks[6]; // \n
  reply.out() << _tntChunks[9]; // \n
  reply.out() << _tntChunks[10]; // \n\n
  reply.out() << _tntChunks[17]; // \n
  reply.out() << _tntChunks[18]; // \n\n
  reply.out() << _tntChunks[20]; // \n
  reply.out() << _tntChunks[21]; // \n\n
  reply.out() << _tntChunks[28]; // \n
  reply.out() << _tntChunks[29]; // \n\n
  reply.out() << _tntChunks[40]; // \n
  reply.out() << _tntChunks[41]; // \n\n
  reply.out() << _tntChunks[49]; // \n
  reply.out() << _tntChunks[50]; // \n\n
  reply.out() << _tntChunks[57]; // \n
  reply.out() << _tntChunks[58]; // \n\n
  reply.out() << _tntChunks[65]; // \n
  reply.out() << _tntChunks[66]; // \n\n
  reply.out() << _tntChunks[73]; // \n
  reply.out() << _tntChunks[74]; // \n\n
  reply.out() << _tntChunks[80]; // \n
  reply.out() << _tntChunks[81]; // \n
  reply.out() << _tntChunks[82]; // \n\n
  reply.out() << _tntChunks[89]; // \n
  reply.out() << _tntChunks[90]; // \n\n
  reply.out() << _tntChunks[97]; // \n
  reply.out() << _tntChunks[98]; // \n\n
  reply.out() << _tntChunks[103]; // \n\n
  reply.out() << _tntChunks[104]; // \n\n
  reply.out() << _tntChunks[114]; // \n
  reply.out() << _tntChunks[115]; // \n\n
  reply.out() << _tntChunks[130]; // \n
  reply.out() << _tntChunks[131]; // \n\n
  reply.out() << _tntChunks[178]; // \n
  reply.out() << _tntChunks[179]; // \n\n
  reply.out() << _tntChunks[360]; // \n
  reply.out() << _tntChunks[361]; // \n
  reply.out() << _tntChunks[365]; // \n\n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::doc_type_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::doc_type " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 47 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
  reply.out() << _tntChunks[2]; // <!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">\n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::create_html_js_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::create_html_js " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 47 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
  reply.out() << _tntChunks[5]; // <script type="text/javascript" src="js/live/createHtml.js"></script>\n<script type="text/javascript" src="js.html"></script>\n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::stylesheets_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::stylesheets " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 47 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
  reply.out() << _tntChunks[7]; // <link rel="stylesheet" type="text/css" href="css/styles.css"/>\n<link rel="stylesheet" type="text/css" href="
#line 65 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("css", "theme.css") );
  reply.out() << _tntChunks[8]; // "/>\n<link rel="stylesheet" type="text/css" href="css/siteprefs.css"/>\n<script type="text/javascript" src="js/live/header.js"></script>\n<script type="text/javascript" src="js/live/epg_tt_box.js"></script>\n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::logo_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::logo " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 47 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
  reply.out() << _tntChunks[11]; // <!-- start of fixed page header -->\n<div id="header" style="width: 100%; background-color: inherit">\n<div id="padding" style="display: none"></div>\n<div id="content">\n<!-- header content follows -->\n
#line 79 "pageelems.ecpp"

  if (LiveSetup().GetShowLogo() || LiveSetup().GetShowInfoBox()) {

  reply.out() << _tntChunks[12]; // <div class="page_header">\n
#line 83 "pageelems.ecpp"

    if (LiveSetup().GetShowLogo()) {

  reply.out() << _tntChunks[13]; // <a href="
#line 86 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetStartScreenLink());
  reply.out() << _tntChunks[14]; // ">\n<img src="
#line 87 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "logo.png") );
  reply.out() << _tntChunks[15]; // " alt="VDR Live!" class="logo" /></a>\n
#line 88 "pageelems.ecpp"

    }

#line 91 "pageelems.ecpp"
if (LiveSetup().GetShowInfoBox()) { 
  // <& infobox ...
  { 
#line 91 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq0;
#line 91 "pageelems.ecpp"
  main().infobox(request, reply, _tnt_cq0);
    // &>
  }
#line 91 "pageelems.ecpp"
 } 
  reply.out() << _tntChunks[16]; // </div>\n<div style="clear: both"></div>\n
#line 94 "pageelems.ecpp"

  }

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::hide_element_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::hide_element " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
int hide = qparam.get< int >("hide", ( 1));
  // </%args>

#line 47 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 105 "pageelems.ecpp"
 if (hide) { 
  reply.out() << _tntChunks[19]; // style="visibility: hidden"
#line 105 "pageelems.ecpp"
 } 
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::progressbar_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::progressbar " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
int progress = qparam.get< int >("progress", ( 0));
std::string id = qparam.get< std::string >("id");
int duration = qparam.get< int >("duration", ( -1));
  // </%args>

#line 47 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 116 "pageelems.ecpp"

  std::string cls("__progress");
  if ((duration >= 0) && ((progress < 0) || (duration == 0)))
    cls +="_invisible";

  reply.out() << _tntChunks[22]; // <div class="
#line 121 "pageelems.ecpp"
  reply.sout() << ( cls );
  reply.out() << _tntChunks[23]; // "><div class="__elapsed" 
#line 121 "pageelems.ecpp"
 if (!id.empty()) { 
  reply.out() << _tntChunks[24]; // id="
#line 121 "pageelems.ecpp"
  reply.sout() << ( id );
  reply.out() << _tntChunks[25]; // " 
#line 121 "pageelems.ecpp"
 } 
  reply.out() << _tntChunks[26]; // style="width: 
#line 121 "pageelems.ecpp"
  reply.sout() << ( progress );
  reply.out() << _tntChunks[27]; // %"></div></div>\n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::ajax_action_href_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::ajax_action_href " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string action = qparam.get< std::string >("action");
std::string tip = qparam.get< std::string >("tip");
std::string param = qparam.get< std::string >("param");
std::string image = qparam.get< std::string >("image");
std::string alt = qparam.get< std::string >("alt");
std::string id = qparam.get< std::string >("id");
  // </%args>

#line 47 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 135 "pageelems.ecpp"
 { 
  reply.out() << _tntChunks[30]; // <a 
#line 135 "pageelems.ecpp"
 if (!id.empty()) { 
  reply.out() << _tntChunks[31]; // id="
#line 135 "pageelems.ecpp"
  reply.sout() << ( id );
  reply.out() << _tntChunks[32]; // " 
#line 135 "pageelems.ecpp"
 } 
  // <& hide_element ...
  { 
#line 135 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq1;
#line 135 "pageelems.ecpp"
    _tnt_cq1.add( "hide", (id.empty()? 0 : 1));
#line 135 "pageelems.ecpp"
  main().hide_element(request, reply, _tnt_cq1);
    // &>
  }
  reply.out() << _tntChunks[33]; //  href="vdr_request/
#line 135 "pageelems.ecpp"
  reply.sout() << ( action );
  reply.out() << _tntChunks[34]; // \?param=
#line 135 "pageelems.ecpp"
  reply.sout() << ( param );
  reply.out() << _tntChunks[35]; // " 
#line 135 "pageelems.ecpp"
if (!tip.empty()) { 
  // <& tooltip.hint ...
  { 
#line 135 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq2;
#line 135 "pageelems.ecpp"
    _tnt_cq2.add( "text", (tip));
#line 135 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq2);
    // &>
  }
  reply.out() << _tntChunks[36]; //  
#line 135 "pageelems.ecpp"
 } 
  reply.out() << _tntChunks[37]; // ><img src="
#line 135 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", image) );
  reply.out() << _tntChunks[38]; // " alt="
#line 135 "pageelems.ecpp"
  reply.sout() << ( alt );
  reply.out() << _tntChunks[39]; // " /></a> 
#line 135 "pageelems.ecpp"
 } 
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::imdb_info_href_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::imdb_info_href " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string title = qparam.get< std::string >("title");
std::string s_IMDB_ID = qparam.get< std::string >("s_IMDB_ID");
  // </%args>

#line 47 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 145 "pageelems.ecpp"

// if (LiveSetup().GetShowIMDb())
{
if (s_IMDB_ID.empty() ) { 
  reply.out() << _tntChunks[42]; // <a href="http://www.imdb.com/find\?s=all&q=
#line 149 "pageelems.ecpp"
  reply.sout() << ( (!title.empty() && title[0] == '%')?cToSvUrlEscaped(cSv(title).substr(1)):cToSvUrlEscaped(title) );
  reply.out() << _tntChunks[43]; // "\n
#line 150 "pageelems.ecpp"
 } else { 
  reply.out() << _tntChunks[44]; // <a href="http://www.imdb.com/title/
#line 151 "pageelems.ecpp"
  reply.sout() << ( s_IMDB_ID );
  reply.out() << _tntChunks[45]; // "\n
#line 152 "pageelems.ecpp"
 } 
  reply.out() << _tntChunks[46]; //  target="_blank"><img src="
#line 153 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "imdb.png") );
  reply.out() << _tntChunks[47]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 153 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq3;
#line 153 "pageelems.ecpp"
    _tnt_cq3.add( "text", (tr("Find more at the Internet Movie Database.")));
#line 153 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq3);
    // &>
  }
  reply.out() << _tntChunks[48]; //  /></a> 
#line 153 "pageelems.ecpp"
 } 
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::hls_channel_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::hls_channel " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string channelId = qparam.get< std::string >("channelId");
std::string class_ = qparam.get< std::string >("class_");
  // </%args>

#line 47 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 163 "pageelems.ecpp"

if (LiveSetup().GetUseStreamdev() && LiveFeatures<features::streamdev_server>().Loaded()) {

  reply.out() << _tntChunks[51]; // <a class="
#line 166 "pageelems.ecpp"
  reply.sout() << (class_);
  reply.out() << _tntChunks[52]; // " href="stream.html\?channelid=
#line 166 "pageelems.ecpp"
  reply.sout() << ( channelId );
  reply.out() << _tntChunks[53]; // "><img class="
#line 166 "pageelems.ecpp"
  reply.sout() << (class_);
  reply.out() << _tntChunks[54]; // " src="
#line 166 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "stream_button.png") );
  reply.out() << _tntChunks[55]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 166 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq4;
#line 166 "pageelems.ecpp"
    _tnt_cq4.add( "text", (tr("Stream this channel into browser.")));
#line 166 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq4);
    // &>
  }
  reply.out() << _tntChunks[56]; //  /></a>\n
#line 167 "pageelems.ecpp"

}

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::hls_recording_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::hls_recording " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string recId = qparam.get< std::string >("recId");
std::string class_ = qparam.get< std::string >("class_");
  // </%args>

#line 47 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 179 "pageelems.ecpp"

if (LiveSetup().GetUseStreamdev() && LiveFeatures<features::streamdev_server>().Loaded()) {

  reply.out() << _tntChunks[59]; // <a class="
#line 182 "pageelems.ecpp"
  reply.sout() << (class_);
  reply.out() << _tntChunks[60]; // " href="stream.html\?recid=
#line 182 "pageelems.ecpp"
  reply.sout() << ( recId );
  reply.out() << _tntChunks[61]; // "><img class="
#line 182 "pageelems.ecpp"
  reply.sout() << (class_);
  reply.out() << _tntChunks[62]; // " src="
#line 182 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "stream_button.png") );
  reply.out() << _tntChunks[63]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 182 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq5;
#line 182 "pageelems.ecpp"
    _tnt_cq5.add( "text", (tr("Stream this recording into browser.")));
#line 182 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq5);
    // &>
  }
  reply.out() << _tntChunks[64]; //  /></a>\n
#line 183 "pageelems.ecpp"

}

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::m3u_playlist_channel_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::m3u_playlist_channel " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string channelId = qparam.get< std::string >("channelId");
std::string class_ = qparam.get< std::string >("class_");
  // </%args>

#line 47 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 195 "pageelems.ecpp"

if (LiveFeatures<features::streamdev_server>().Loaded()) {

  reply.out() << _tntChunks[67]; // <a class="
#line 198 "pageelems.ecpp"
  reply.sout() << (class_);
  reply.out() << _tntChunks[68]; // " href="playlist.m3u\?channelid=
#line 198 "pageelems.ecpp"
  reply.sout() << ( channelId );
  reply.out() << _tntChunks[69]; // " download><img class="
#line 198 "pageelems.ecpp"
  reply.sout() << (class_);
  reply.out() << _tntChunks[70]; // " src="
#line 198 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "playlist.png") );
  reply.out() << _tntChunks[71]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 198 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq6;
#line 198 "pageelems.ecpp"
    _tnt_cq6.add( "text", (tr("Stream this channel into media player.")));
#line 198 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq6);
    // &>
  }
  reply.out() << _tntChunks[72]; //  /></a>\n
#line 199 "pageelems.ecpp"

}

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::m3u_playlist_recording_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::m3u_playlist_recording " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string recid = qparam.get< std::string >("recid");
std::string linkText = qparam.get< std::string >("linkText");
  // </%args>

#line 47 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 211 "pageelems.ecpp"

#if TNT_WATCHDOG_SILENCE
// <a href="intent://my.example.com:8080/test.mp4#Intent;scheme=http;package=org.videolan.vlc;end">OPEN IN VLC</a>

// std::string server = request.getHost();
// server = server.substr(0, server.rfind(':'));
// cToSvConcat url("intent://", server, ":", LiveSetup().GetServerPort(), "/recstream.html?recid=", recid, "#Intent;scheme=http;package=org.videolan.vlc;end");

cToSvConcat url("playlist.m3u?recid=", recid);
{

  reply.out() << _tntChunks[75]; // <a href="
#line 221 "pageelems.ecpp"
  reply.sout() << ( url );
  reply.out() << _tntChunks[76]; // " download><img src="
#line 221 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "playlist.png") );
  reply.out() << _tntChunks[77]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 221 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq7;
#line 221 "pageelems.ecpp"
    _tnt_cq7.add( "text", (tr("Stream this recording into media player.")));
#line 221 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq7);
    // &>
  }
  reply.out() << _tntChunks[78]; //  /> 
#line 221 "pageelems.ecpp"
  reply.sout() << ( linkText );
  reply.out() << _tntChunks[79]; // </a>\n
#line 222 "pageelems.ecpp"

}
#endif

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::stream_recording_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::stream_recording " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string recid = qparam.get< std::string >("recid");
std::string linkText = qparam.get< std::string >("linkText");
  // </%args>

#line 47 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 236 "pageelems.ecpp"

#if TNT_WATCHDOG_SILENCE
cToSvConcat rfid;
{
  const cRecording* recording = nullptr;
  LOCK_RECORDINGS_READ
  if (!recid.empty()) recording = RecordingsManager::GetByHash(recid, Recordings);
  if (recording) {
    struct stat st;
    if (stat(recording->FileName(), &st) == 0)
      rfid.appendFormated("%lu:%llu.rec", (unsigned long) st.st_dev, (unsigned long long) st.st_ino);
  }
}
if (!rfid.empty() ) {

  reply.out() << _tntChunks[83]; // <a href="http://localhost:
#line 250 "pageelems.ecpp"
  reply.sout() << (cToSvConcat(LiveSetup().GetStreamdevPort()));
  reply.out() << _tntChunks[84]; // /
#line 250 "pageelems.ecpp"
  reply.sout() << (rfid);
  reply.out() << _tntChunks[85]; // .ts"><img src="
#line 250 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "playlist.png") );
  reply.out() << _tntChunks[86]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 250 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq8;
#line 250 "pageelems.ecpp"
    _tnt_cq8.add( "text", (tr("Stream this recording.")));
#line 250 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq8);
    // &>
  }
  reply.out() << _tntChunks[87]; //  /> 
#line 250 "pageelems.ecpp"
  reply.sout() << ( linkText );
  reply.out() << _tntChunks[88]; // </a>\n
#line 251 "pageelems.ecpp"

}
#endif

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::event_timer_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::event_timer " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string epgid = qparam.get< std::string >("epgid");
  // </%args>

#line 47 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 263 "pageelems.ecpp"

  tChannelID channelid;
  tEventID eventid;
  EpgEvents::DecodeDomId(epgid, channelid, eventid);
  std::string timerId;
  bool timerRecording = false;
  bool timerActive = true;
  {
    LOCK_TIMERS_READ;
    const cTimer* timer = TimerManager::GetTimer(eventid, channelid, Timers);
    if (timer) {
      timerId = SortedTimers::GetTimerId(*timer);
      timerRecording = timer->Recording();
      timerActive = timer->Flags() & tfActive;
    }
  }
  if (!timerId.empty() ) {

  reply.out() << _tntChunks[91]; //     
  // <& pageelems.edit_timer ...
  { 
#line 281 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq9;
#line 281 "pageelems.ecpp"
    _tnt_cq9.add( "imgName", (timerRecording ? "recording_timer.gif" : (timerActive ? "record_timer.png" : "record_inactive_timer.png")));
#line 281 "pageelems.ecpp"
    _tnt_cq9.add( "timerId", (timerId));
#line 281 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "edit_timer"), request, reply, _tnt_cq9);
    // &>
  }
  reply.out() << _tntChunks[92]; // \n
#line 282 "pageelems.ecpp"

  }
  else {

  reply.out() << _tntChunks[93]; //     <a href="edit_timer.html\?epgid=
#line 286 "pageelems.ecpp"
  reply.sout() << ( epgid );
  reply.out() << _tntChunks[94]; // "><img src="
#line 286 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "record.png") );
  reply.out() << _tntChunks[95]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 286 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq10;
#line 286 "pageelems.ecpp"
    _tnt_cq10.add( "text", (tr("Record this")));
#line 286 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq10);
    // &>
  }
  reply.out() << _tntChunks[96]; //  /></a>\n
#line 287 "pageelems.ecpp"

  }

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::edit_timer_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::edit_timer " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string timerId = qparam.get< std::string >("timerId");
std::string imgName = qparam.get< std::string >("imgName", ( "edit.png"));
  // </%args>

#line 47 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
  reply.out() << _tntChunks[99]; //   <a href="edit_timer.html\?timerid=
#line 299 "pageelems.ecpp"
  reply.sout() << ( SortedTimers::EncodeDomId(timerId) );
  reply.out() << _tntChunks[100]; // "><img src="
#line 299 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", imgName) );
  reply.out() << _tntChunks[101]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 299 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq11;
#line 299 "pageelems.ecpp"
    _tnt_cq11.add( "text", (tr("Edit timer")));
#line 299 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq11);
    // &>
  }
  reply.out() << _tntChunks[102]; //  /></a>\n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::ajax_js_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::ajax_js " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 47 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
  reply.out() << _tntChunks[105]; //   <script type="text/javascript" src="js/mootools/mootools.v1.11.js"></script>\n  <script type="text/javascript" src="js/live/liveajax.js"></script>\n  <script type="text/javascript" src="js/live/infowin.js"></script>\n  <script type="text/javascript" src="js/live/hinttips.js"></script>\n  <script type="text/javascript" src="js/live/browserwin.js"></script>\n  <script type="text/javascript" src="js/live/pageenhance.js"></script>\n  <script type="text/javascript"><!--\n    var liveEnhanced = new PageEnhance({\n        infoWinOptions: {\n          buttonimg: 'img/transparent.png',\n          loadingMsg: '
#line 316 "pageelems.ecpp"
  reply.sout() << ( tr("loading data") );
  reply.out() << _tntChunks[106]; // ',\n          errorMsg: '
#line 317 "pageelems.ecpp"
  reply.sout() << ( tr("an error occurred!") );
  reply.out() << _tntChunks[107]; // '\n        },\n        notifyStrings: {\n          successMsg: '<img src="
#line 320 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "active.png") );
  reply.out() << _tntChunks[108]; // " alt=""> 
#line 320 "pageelems.ecpp"
  reply.sout() << ( tr("Request succeeded!") );
  reply.out() << _tntChunks[109]; // ',\n          errorMsg: '<img src="
#line 321 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "del.png") );
  reply.out() << _tntChunks[110]; // " alt=""> 
#line 321 "pageelems.ecpp"
  reply.sout() << ( tr("Request failed!") );
  reply.out() << _tntChunks[111]; // '\n        }\n      });\n  --></script>\n
#line 325 "pageelems.ecpp"

    if (LiveSetup().GetShowInfoBox()) {

  reply.out() << _tntChunks[112]; //   <script type="text/javascript" src="js/live/vdr_status.js"></script>\n  <script type="text/javascript"><!--\n    var InfoBox = new LiveVdrInfo('ibox.xml', 'infobox');\n    window.addEvent('domready', function(){\n      InfoBox.request(
#line 332 "pageelems.ecpp"
 if (update_status) { reply.sout() << "true"; } else { reply.sout() << "false"; } 
  reply.out() << _tntChunks[113]; // );\n    });\n    window.addEvent('unload', function(){\n      InfoBox.pageFinished();\n    });\n  --></script>\n
#line 338 "pageelems.ecpp"

    }

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::infobox_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::infobox " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 47 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
  reply.out() << _tntChunks[116]; // <div id="infobox">\n  <div class="statuscontent">\n    <div class="st_header">\n      <div id="infobox_caption" class="caption">
#line 349 "pageelems.ecpp"
  reply.sout() << ( tr("retrieving status ...") );
  reply.out() << _tntChunks[117]; // </div>\n      <div id="infobox_timenow" class="now">--:--</div>\n    </div>\n    <div class="st_content">\n      <div id="infobox_name" class="name"></div>\n      <div id="infobox_duration" class="duration">--:--</div>\n    </div>\n    <div class="st_controls">\n      <div class="st_update">\n        <a href="javascript:InfoBox.toggleUpdate()" 
  // <& tooltip.hint ...
  { 
#line 358 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq12;
#line 358 "pageelems.ecpp"
    _tnt_cq12.add( "text", (tr("Toggle updates on/off.")));
#line 358 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq12);
    // &>
  }
  reply.out() << _tntChunks[118]; // ><img id="statusReloadBtn" src="
#line 358 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "stop_update.png") );
  reply.out() << _tntChunks[119]; // " alt="" /></a>\n      </div>\n      <div id="infobox_recording_buttons" style="display: none">\n        
  // <& ajax_action_href ...
  { 
#line 361 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq13;
#line 361 "pageelems.ecpp"
    _tnt_cq13.add( "action", ("stop_recording"));
#line 361 "pageelems.ecpp"
    _tnt_cq13.add( "id", ("infobox_stop"));
#line 361 "pageelems.ecpp"
    _tnt_cq13.add( "image", ("stop.png"));
#line 361 "pageelems.ecpp"
    _tnt_cq13.add( "tip", (tr("stop playback")));
#line 361 "pageelems.ecpp"
  main().ajax_action_href(request, reply, _tnt_cq13);
    // &>
  }
  reply.out() << _tntChunks[120]; // \n        
  // <& ajax_action_href ...
  { 
#line 362 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq14;
#line 362 "pageelems.ecpp"
    _tnt_cq14.add( "action", ("play_recording"));
#line 362 "pageelems.ecpp"
    _tnt_cq14.add( "id", ("infobox_play"));
#line 362 "pageelems.ecpp"
    _tnt_cq14.add( "image", ("play.png"));
#line 362 "pageelems.ecpp"
    _tnt_cq14.add( "tip", (tr("resume playback")));
#line 362 "pageelems.ecpp"
  main().ajax_action_href(request, reply, _tnt_cq14);
    // &>
  }
  reply.out() << _tntChunks[121]; // \n        
  // <& ajax_action_href ...
  { 
#line 363 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq15;
#line 363 "pageelems.ecpp"
    _tnt_cq15.add( "action", ("pause_recording"));
#line 363 "pageelems.ecpp"
    _tnt_cq15.add( "id", ("infobox_pause"));
#line 363 "pageelems.ecpp"
    _tnt_cq15.add( "image", ("pause.png"));
#line 363 "pageelems.ecpp"
    _tnt_cq15.add( "tip", (tr("pause playback")));
#line 363 "pageelems.ecpp"
  main().ajax_action_href(request, reply, _tnt_cq15);
    // &>
  }
  reply.out() << _tntChunks[122]; // \n        
  // <& ajax_action_href ...
  { 
#line 364 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq16;
#line 364 "pageelems.ecpp"
    _tnt_cq16.add( "action", ("rwd_recording"));
#line 364 "pageelems.ecpp"
    _tnt_cq16.add( "id", ("infobox_rwd"));
#line 364 "pageelems.ecpp"
    _tnt_cq16.add( "image", ("rwd.png"));
#line 364 "pageelems.ecpp"
    _tnt_cq16.add( "tip", (tr("fast rewind")));
#line 364 "pageelems.ecpp"
  main().ajax_action_href(request, reply, _tnt_cq16);
    // &>
  }
  reply.out() << _tntChunks[123]; // \n        
  // <& ajax_action_href ...
  { 
#line 365 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq17;
#line 365 "pageelems.ecpp"
    _tnt_cq17.add( "action", ("ffw_recording"));
#line 365 "pageelems.ecpp"
    _tnt_cq17.add( "id", ("infobox_ffw"));
#line 365 "pageelems.ecpp"
    _tnt_cq17.add( "image", ("ffw.png"));
#line 365 "pageelems.ecpp"
    _tnt_cq17.add( "tip", (tr("fast forward")));
#line 365 "pageelems.ecpp"
  main().ajax_action_href(request, reply, _tnt_cq17);
    // &>
  }
  reply.out() << _tntChunks[124]; // \n      </div>\n      <div id="infobox_channel_buttons">\n        
  // <& ajax_action_href ...
  { 
#line 368 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq18;
#line 368 "pageelems.ecpp"
    _tnt_cq18.add( "action", ("switch_channel"));
#line 368 "pageelems.ecpp"
    _tnt_cq18.add( "id", ("infobox_prevchan"));
#line 368 "pageelems.ecpp"
    _tnt_cq18.add( "image", ("one_downarrow.png"));
#line 368 "pageelems.ecpp"
    _tnt_cq18.add( "tip", (tr("previous channel")));
#line 368 "pageelems.ecpp"
  main().ajax_action_href(request, reply, _tnt_cq18);
    // &>
  }
  reply.out() << _tntChunks[125]; // \n        
  // <& ajax_action_href ...
  { 
#line 369 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq19;
#line 369 "pageelems.ecpp"
    _tnt_cq19.add( "action", ("switch_channel"));
#line 369 "pageelems.ecpp"
    _tnt_cq19.add( "id", ("infobox_nextchan"));
#line 369 "pageelems.ecpp"
    _tnt_cq19.add( "image", ("one_uparrow.png"));
#line 369 "pageelems.ecpp"
    _tnt_cq19.add( "tip", (tr("next channel")));
#line 369 "pageelems.ecpp"
  main().ajax_action_href(request, reply, _tnt_cq19);
    // &>
  }
  reply.out() << _tntChunks[126]; // \n      </div>\n      <div class="st_pbar">\n        
  // <& progressbar ...
  { 
#line 372 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq20;
#line 372 "pageelems.ecpp"
    _tnt_cq20.add( "id", ("infobox_elapsed"));
#line 372 "pageelems.ecpp"
  main().progressbar(request, reply, _tnt_cq20);
    // &>
  }
  reply.out() << _tntChunks[127]; // \n      </div>\n    </div>\n  </div>\n  <div style="display: none;">\n    <span id="__infobox_request_err">
#line 377 "pageelems.ecpp"
  reply.sout() << ( tr("No server response!") );
  reply.out() << _tntChunks[128]; // </span>\n    <span id="__infobox_update_err">
#line 378 "pageelems.ecpp"
  reply.sout() << ( tr("Failed to update infobox!") );
  reply.out() << _tntChunks[129]; // </span>\n  </div>\n</div>\n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::epg_tool_box_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::epg_tool_box " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
int detail = qparam.get< int >("detail");
std::string epgid = qparam.get< std::string >("epgid");
std::string title = qparam.get< std::string >("title");
time_t startTime = qparam.get< time_t >("startTime");
time_t endTime = qparam.get< time_t >("endTime");
int lastCurrentChanel = qparam.get< int >("lastCurrentChanel", ( int()));
std::string s_IMDB_ID = qparam.get< std::string >("s_IMDB_ID");
  // </%args>

#line 47 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 395 "pageelems.ecpp"

  int duration = EpgEvents::Duration(startTime, endTime);
  int elapsed = EpgEvents::ElapsedTime(startTime, endTime);
  tEventID eventId = tEventID();
  tChannelID channelId = tChannelID();

  EpgEvents::DecodeDomId(epgid, channelId, eventId);
  if (detail) { // output for vertical toolbox

  reply.out() << _tntChunks[132]; //   
  // <& pageelems.event_timer ...
  { 
#line 404 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq21;
#line 404 "pageelems.ecpp"
    _tnt_cq21.add( "epgid", (epgid));
#line 404 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "event_timer"), request, reply, _tnt_cq21);
    // &>
  }
  reply.out() << _tntChunks[133]; // \n
#line 405 "pageelems.ecpp"
 if (cDevice::PrimaryDevice() && cDevice::PrimaryDevice()->HasDecoder() ) {

  reply.out() << _tntChunks[134]; //     
  // <& pageelems.ajax_action_href ...
  { 
#line 406 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq22;
#line 406 "pageelems.ecpp"
    _tnt_cq22.add( "action", "switch_channel");
#line 406 "pageelems.ecpp"
    _tnt_cq22.add( "alt", "");
#line 406 "pageelems.ecpp"
    _tnt_cq22.add( "image", "zap.png");
#line 406 "pageelems.ecpp"
    _tnt_cq22.add( "param", (channelId));
#line 406 "pageelems.ecpp"
    _tnt_cq22.add( "tip", (tr("Switch to this channel.")));
#line 406 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_action_href"), request, reply, _tnt_cq22);
    // &>
  }
  reply.out() << _tntChunks[135]; // \n
#line 407 "pageelems.ecpp"
 } if (LiveFeatures<features::epgsearch>().Recent() && eventId != 0) {

  reply.out() << _tntChunks[136]; //   <a href="searchresults.html\?searchplain=
#line 408 "pageelems.ecpp"
  reply.out() << ( cToSvUrlEscaped(title) );
  reply.out() << _tntChunks[137]; // "><img src="
#line 408 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "search.png") );
  reply.out() << _tntChunks[138]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 408 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq23;
#line 408 "pageelems.ecpp"
    _tnt_cq23.add( "text", (tr("Search for repeats.")));
#line 408 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq23);
    // &>
  }
  reply.out() << _tntChunks[139]; //  /></a>\n
#line 409 "pageelems.ecpp"
 } if ((duration == 0) || (elapsed >= 0)) {

  reply.out() << _tntChunks[140]; //   
  // <& pageelems.hls_channel ...
  { 
#line 410 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq24;
#line 410 "pageelems.ecpp"
    _tnt_cq24.add( "channelId", (channelId));
#line 410 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "hls_channel"), request, reply, _tnt_cq24);
    // &>
  }
  reply.out() << _tntChunks[141]; // \n  
  // <& pageelems.m3u_playlist_channel ...
  { 
#line 411 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq25;
#line 411 "pageelems.ecpp"
    _tnt_cq25.add( "channelId", (channelId));
#line 411 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "m3u_playlist_channel"), request, reply, _tnt_cq25);
    // &>
  }
  reply.out() << _tntChunks[142]; // \n
#line 412 "pageelems.ecpp"
 } if (!title.empty()) {

  reply.out() << _tntChunks[143]; //   
  // <& pageelems.imdb_info_href ...
  { 
#line 413 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq26;
#line 413 "pageelems.ecpp"
    _tnt_cq26.add( "s_IMDB_ID", (s_IMDB_ID));
#line 413 "pageelems.ecpp"
    _tnt_cq26.add( "title", (title));
#line 413 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "imdb_info_href"), request, reply, _tnt_cq26);
    // &>
  }
  reply.out() << _tntChunks[144]; // \n
#line 414 "pageelems.ecpp"

  }
  if (eventId != 0 && detail > 1) {
    const char *sdhd = nullptr;
    std::string channel_Name;
    {
      LOCK_CHANNELS_READ;
      LOCK_SCHEDULES_READ;
      const cEvent* event;
      const cChannel* channel;
      EpgEvents::GetEventChannelByEpgId(event, channel, epgid, Channels, Schedules);
      cGetScraperVideo getScraperVideo(event, nullptr);
      bool scraperDataAvailable = getScraperVideo.call(LiveSetup().GetPluginTvscraper());
      if (scraperDataAvailable) {
        int video_SD_HD = getScraperVideo.m_scraperVideo->getHD();
        sdhd = video_SD_HD == 0 ? "sd": video_SD_HD == 1 ? "hd": video_SD_HD == 2 ? "ud" : nullptr;
        if (channel) channel_Name = cSv(channel->Name());
      }
    }
    if (sdhd) {

  reply.out() << _tntChunks[145]; // <img data-src="img/transparent.png" height="10px" />\n<span id="icons-
#line 436 "pageelems.ecpp"
  reply.sout() << (epgid);
  reply.out() << _tntChunks[146]; // "></span>\n<script class="injectIcons">\ninjectHdSdIcon("icons-
#line 438 "pageelems.ecpp"
  reply.sout() << (epgid);
  reply.out() << _tntChunks[147]; // ", "
#line 438 "pageelems.ecpp"
  reply.sout() << (sdhd);
  reply.out() << _tntChunks[148]; // ", "
#line 438 "pageelems.ecpp"
  reply.sout() << ( channel_Name );
  reply.out() << _tntChunks[149]; // ", "")\n</script>\n
#line 440 "pageelems.ecpp"

    }
  }
  } else { // table output

  reply.out() << _tntChunks[150]; //   <td class="action leftcol 
#line 445 "pageelems.ecpp"
  if ( lastCurrentChanel )
    reply.sout() <<  "bottomrow";
  reply.out() << _tntChunks[151]; // ">
  // <& pageelems.event_timer ...
  { 
#line 445 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq27;
#line 445 "pageelems.ecpp"
    _tnt_cq27.add( "epgid", (epgid));
#line 445 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "event_timer"), request, reply, _tnt_cq27);
    // &>
  }
  reply.out() << _tntChunks[152]; // </td>\n
#line 446 "pageelems.ecpp"
 if (cDevice::PrimaryDevice() && cDevice::PrimaryDevice()->HasDecoder() ) {

  reply.out() << _tntChunks[153]; //     <td class="action 
#line 447 "pageelems.ecpp"
  if ( lastCurrentChanel )
    reply.sout() <<  "bottomrow";
  reply.out() << _tntChunks[154]; // ">
  // <& pageelems.ajax_action_href ...
  { 
#line 447 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq28;
#line 447 "pageelems.ecpp"
    _tnt_cq28.add( "action", "switch_channel");
#line 447 "pageelems.ecpp"
    _tnt_cq28.add( "alt", "");
#line 447 "pageelems.ecpp"
    _tnt_cq28.add( "image", "zap.png");
#line 447 "pageelems.ecpp"
    _tnt_cq28.add( "param", (channelId));
#line 447 "pageelems.ecpp"
    _tnt_cq28.add( "tip", (tr("Switch to this channel.")));
#line 447 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_action_href"), request, reply, _tnt_cq28);
    // &>
  }
  reply.out() << _tntChunks[155]; // </td>\n
#line 448 "pageelems.ecpp"
 } if (LiveFeatures<features::epgsearch>().Recent()) {

  reply.out() << _tntChunks[156]; //       <td class="action 
#line 449 "pageelems.ecpp"
  if ( lastCurrentChanel )
    reply.sout() <<  "bottomrow";
  reply.out() << _tntChunks[157]; // ">\n
#line 450 "pageelems.ecpp"
     if (eventId) {

  reply.out() << _tntChunks[158]; //         <a href="searchresults.html\?searchplain=
#line 451 "pageelems.ecpp"
  reply.out() << ( cToSvUrlEscaped(title) );
  reply.out() << _tntChunks[159]; // "><img src="
#line 451 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "search.png") );
  reply.out() << _tntChunks[160]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 451 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq29;
#line 451 "pageelems.ecpp"
    _tnt_cq29.add( "text", (tr("Search for repeats.")));
#line 451 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq29);
    // &>
  }
  reply.out() << _tntChunks[161]; //  /></a>\n
#line 452 "pageelems.ecpp"
     }

  reply.out() << _tntChunks[162]; //       </td>\n
#line 454 "pageelems.ecpp"
 } if (LiveSetup().GetUseStreamdev() && LiveFeatures<features::streamdev_server>().Loaded() ) {

  reply.out() << _tntChunks[163]; //     <td class="td-hidden-xs action
#line 455 "pageelems.ecpp"
  if ( lastCurrentChanel )
    reply.sout() <<  " bottomrow";
  reply.out() << _tntChunks[164]; // ">\n
#line 456 "pageelems.ecpp"
   if ((duration == 0) || (elapsed > 0)) {

  reply.out() << _tntChunks[165]; //       
  // <& pageelems.hls_channel ...
  { 
#line 457 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq30;
#line 457 "pageelems.ecpp"
    _tnt_cq30.add( "channelId", (channelId));
#line 457 "pageelems.ecpp"
    _tnt_cq30.add( "class_", ("hidden-xs"));
#line 457 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "hls_channel"), request, reply, _tnt_cq30);
    // &>
  }
  reply.out() << _tntChunks[166]; // \n
#line 458 "pageelems.ecpp"
   }

  reply.out() << _tntChunks[167]; //     </td>\n
#line 460 "pageelems.ecpp"
 } if (LiveFeatures<features::streamdev_server>().Loaded() ) {

  reply.out() << _tntChunks[168]; //     <td class="td-hidden-xs action
#line 461 "pageelems.ecpp"
  if ( lastCurrentChanel )
    reply.sout() <<  " bottomrow";
  reply.out() << _tntChunks[169]; // ">\n
#line 462 "pageelems.ecpp"
   if ((duration == 0) || (elapsed > 0)) {

  reply.out() << _tntChunks[170]; //       
  // <& pageelems.m3u_playlist_channel ...
  { 
#line 463 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq31;
#line 463 "pageelems.ecpp"
    _tnt_cq31.add( "channelId", (channelId));
#line 463 "pageelems.ecpp"
    _tnt_cq31.add( "class_", ("hidden-xs"));
#line 463 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "m3u_playlist_channel"), request, reply, _tnt_cq31);
    // &>
  }
  reply.out() << _tntChunks[171]; // \n
#line 464 "pageelems.ecpp"
   }

  reply.out() << _tntChunks[172]; //     </td>\n
#line 466 "pageelems.ecpp"
 } if (LiveSetup().GetShowIMDb() ) {

  reply.out() << _tntChunks[173]; //     <td class="action 
#line 467 "pageelems.ecpp"
  if ( lastCurrentChanel )
    reply.sout() <<  "bottomrow";
  reply.out() << _tntChunks[174]; // ">\n
#line 468 "pageelems.ecpp"
   if (eventId != 0) {

  reply.out() << _tntChunks[175]; //       
  // <& pageelems.imdb_info_href ...
  { 
#line 469 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq32;
#line 469 "pageelems.ecpp"
    _tnt_cq32.add( "s_IMDB_ID", (s_IMDB_ID));
#line 469 "pageelems.ecpp"
    _tnt_cq32.add( "title", (title));
#line 469 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "imdb_info_href"), request, reply, _tnt_cq32);
    // &>
  }
  reply.out() << _tntChunks[176]; // \n
#line 470 "pageelems.ecpp"
   }

  reply.out() << _tntChunks[177]; //     </td>\n
#line 472 "pageelems.ecpp"
} }

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::epg_tt_box_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::epg_tt_box " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string boxId = qparam.get< std::string >("boxId");
std::string caption = qparam.get< std::string >("caption");
std::string tools_comp = qparam.get< std::string >("tools_comp");
std::string time = qparam.get< std::string >("time");
std::string channel = qparam.get< std::string >("channel");
std::string title = qparam.get< std::string >("title");
std::string short_descr = qparam.get< std::string >("short_descr");
std::string long_descr = qparam.get< std::string >("long_descr");
std::string filename = qparam.get< std::string >("filename");
std::string archived = qparam.get< std::string >("archived");
std::string epgImage = qparam.get< std::string >("epgImage");
uintptr_t iepgEvent = qparam.get< uintptr_t >("iepgEvent");
int elapsed = qparam.get< int >("elapsed", ( -1));
std::string sort = qparam.get< std::string >("sort");
std::string filter = qparam.get< std::string >("filter");
std::string flat = qparam.get< std::string >("flat");
int history_num_back = qparam.get< int >("history_num_back", ( 0));
  // </%args>

#line 47 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
  reply.out() << _tntChunks[180]; //   <div class="epg_description" id="
#line 497 "pageelems.ecpp"
  reply.sout() << ( (boxId) );
  reply.out() << _tntChunks[181]; // ">\n    <div class="station">\n      <div class="boxheader">\n\n<div>\n
#line 502 "pageelems.ecpp"

struct sEpisode2 {
    int number;
    int season;
    int absoluteNumber;
    std::string name;
    std::string firstAired;
    int runtime;
    std::string overview;
    float vote_average;
    int vote_count;
    cTvMedia episodeImage;
    std::string IMDB_ID;
};
struct sScraperMovieOrTv {
    bool found;
    bool movie;
    std::string title;
    std::string originalTitle;
    std::string tagline;
    std::string overview;
    std::vector<std::string> genres;
    std::string homepage;
    std::string releaseDate;  // for TV shows: firstAired
    bool adult;
    int runtime;
    float popularity;
    float voteAverage;
    int voteCount;
    std::vector<std::string> productionCountries;
    std::string IMDB_ID;
    std::vector<cTvMedia> posters;
    std::vector<cTvMedia> banners;
    std::vector<cTvMedia> fanarts;
// only for movies
    int budget;
    int revenue;
    int collectionId;
    std::string collectionName;
// only for TV Shows
    std::string status;
    std::vector<std::string> networks;
    int lastSeason;
// episode related
    bool episodeFound;
    cTvMedia seasonPoster;
    sEpisode2 episode;
};

EpgInfoPtr epgEvent = iepgEvent?static_cast<EpgInfo*>((void *)iepgEvent):nullptr;
sScraperMovieOrTv scraperMovieOrTv;
scraperMovieOrTv.found = false;

if (epgEvent && epgEvent->ScraperVideoAvailable()) {
  scraperMovieOrTv.found = true;
  tvType type = epgEvent->GetScraperVideo()->getVideoType();
//  esyslog("live: type = %i", (int)type);
  if (type == tMovie) scraperMovieOrTv.movie = true;
  else {
    if (type == tSeries) scraperMovieOrTv.movie = false;
    else scraperMovieOrTv.found = false;
  }
}
if (scraperMovieOrTv.found) {
  scraperMovieOrTv.found = epgEvent->GetScraperVideo()->getMovieOrTv(&scraperMovieOrTv.title, &scraperMovieOrTv.originalTitle, &scraperMovieOrTv.tagline, &scraperMovieOrTv.overview, &scraperMovieOrTv.genres, &scraperMovieOrTv.homepage, &scraperMovieOrTv.releaseDate, &scraperMovieOrTv.adult, &scraperMovieOrTv.runtime, &scraperMovieOrTv.popularity, &scraperMovieOrTv.voteAverage, &scraperMovieOrTv.voteCount, &scraperMovieOrTv.productionCountries, &scraperMovieOrTv.IMDB_ID, &scraperMovieOrTv.budget, &scraperMovieOrTv.revenue, &scraperMovieOrTv.collectionId, &scraperMovieOrTv.collectionName, &scraperMovieOrTv.status, &scraperMovieOrTv.networks, &scraperMovieOrTv.lastSeason);
}

std::vector<std::unique_ptr<cCharacter>> scraperCharacters;
if (scraperMovieOrTv.found) {
  scraperCharacters = epgEvent->GetScraperVideo()->getCharacters(false);
  scraperMovieOrTv.posters = epgEvent->GetScraperVideo()->getImages(eOrientation::portrait, 3, false);
  scraperMovieOrTv.banners = epgEvent->GetScraperVideo()->getImages(eOrientation::banner, 3, false);
  scraperMovieOrTv.fanarts = epgEvent->GetScraperVideo()->getImages(eOrientation::landscape, 3, false);
  scraperMovieOrTv.episodeFound = epgEvent->GetScraperVideo()->getEpisode(&scraperMovieOrTv.episode.name, &scraperMovieOrTv.episode.overview, &scraperMovieOrTv.episode.absoluteNumber, &scraperMovieOrTv.episode.firstAired, &scraperMovieOrTv.episode.runtime, &scraperMovieOrTv.episode.vote_average, &scraperMovieOrTv.episode.vote_count, &scraperMovieOrTv.episode.IMDB_ID);
  if (scraperMovieOrTv.episodeFound) {
    scraperMovieOrTv.episode.number = epgEvent->GetScraperVideo()->getEpisodeNumber();
    scraperMovieOrTv.episode.season = epgEvent->GetScraperVideo()->getSeasonNumber();
    scraperMovieOrTv.episode.episodeImage = epgEvent->GetScraperVideo()->getImage(cImageLevels(eImageLevel::episodeMovie), cOrientations(eOrientation::landscape), false);
    scraperMovieOrTv.seasonPoster = epgEvent->GetScraperVideo()->getImage(cImageLevels(eImageLevel::seasonMovie), cOrientations(eOrientation::portrait), false);
  }
}

const bool episodeFound = scraperMovieOrTv.found && (!scraperMovieOrTv.movie) && scraperMovieOrTv.episodeFound;
if (scraperMovieOrTv.found) {
//  esyslog("live: create caption menu");

  reply.out() << _tntChunks[182]; // <div class = "caption">\n  <a id="
#line 589 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[183]; // _epg_m"     class = "active"   onclick="displayEPG('
#line 589 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[184]; // ')" >
#line 589 "pageelems.ecpp"
  reply.sout() << ( trVDR("EPG") );
  reply.out() << _tntChunks[185]; // </a>\n| <a id="
#line 590 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[186]; // _scraper_m" class = "inactive" onclick="displayScraper('
#line 590 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[187]; // ')">
#line 590 "pageelems.ecpp"
  reply.sout() << ( tr("Scraper") );
  reply.out() << _tntChunks[188]; // </a>\n| <a id="
#line 591 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[189]; // _actors_m"  class = "inactive" onclick="displayActors('
#line 591 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[190]; // ')" >
#line 591 "pageelems.ecpp"
  reply.sout() << ( tr("Actors") );
  reply.out() << _tntChunks[191]; // </a>\n| <a id="
#line 592 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[192]; // _artwork_m" class = "inactive" onclick="displayArtwork('
#line 592 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[193]; // ')" >
#line 592 "pageelems.ecpp"
  reply.sout() << ( tr("Artwork") );
  reply.out() << _tntChunks[194]; // </a>\n</div>\n
#line 594 "pageelems.ecpp"

} else {

  reply.out() << _tntChunks[195]; // <div class="caption">
#line 597 "pageelems.ecpp"
  reply.sout() << ( (caption) );
  reply.out() << _tntChunks[196]; // </div>\n
#line 598 "pageelems.ecpp"

}

  reply.out() << _tntChunks[197]; // </div>\n                        </div>\n    </div>\n    <div class="epg_content">\n      <div class="epg_tools">\n        
  // <& (tools_comp) ...
  { 
#line 606 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq33;
#line 606 "pageelems.ecpp"
    _tnt_cq33.add( "archived", (archived));
#line 606 "pageelems.ecpp"
    _tnt_cq33.add( "detail", (2));
#line 606 "pageelems.ecpp"
    _tnt_cq33.add( "filter", (filter));
#line 606 "pageelems.ecpp"
    _tnt_cq33.add( "flat", (flat));
#line 606 "pageelems.ecpp"
    _tnt_cq33.add( "history_num_back", (history_num_back));
#line 606 "pageelems.ecpp"
    _tnt_cq33.add( "id", (boxId));
#line 606 "pageelems.ecpp"
    _tnt_cq33.add( "s_IMDB_ID", (scraperMovieOrTv.IMDB_ID));
#line 606 "pageelems.ecpp"
    _tnt_cq33.add( "sort", (sort));
#line 606 "pageelems.ecpp"
    _tnt_cq33.add( "title", (title));
#line 606 "pageelems.ecpp"
    callComp((tools_comp), request, reply, _tnt_cq33);
    // &>
  }
  reply.out() << _tntChunks[198]; // \n      </div>\n      <div class="epg_info">\n        <div class="info">\n          <div class="duration">\n
#line 611 "pageelems.ecpp"

if (epgEvent && epgEvent->isRecording() ) {  // recording

  reply.out() << _tntChunks[199]; //             <span title="
#line 614 "pageelems.ecpp"
  reply.sout() << (tr("Recording length"));
  reply.out() << _tntChunks[200]; // ">
#line 614 "pageelems.ecpp"
  reply.sout() << ( FormatDuration(tr("%d:%02d"), epgEvent->Duration()));
  reply.out() << _tntChunks[201]; // </span> / <span title="
#line 614 "pageelems.ecpp"
  reply.sout() << (tr("Event duration"));
  reply.out() << _tntChunks[202]; // ">
#line 614 "pageelems.ecpp"
  reply.sout() << (FormatDuration(tr("%d:%02d"), epgEvent->EventDuration()));
  reply.out() << _tntChunks[203]; // </span>\n
#line 615 "pageelems.ecpp"

}
if (elapsed >= 0) {

  reply.out() << _tntChunks[204]; //             <div class="progress"><div>
  // <& pageelems.progressbar ...
  { 
#line 619 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq34;
#line 619 "pageelems.ecpp"
    _tnt_cq34.add( "progress", (elapsed));
#line 619 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "progressbar"), request, reply, _tnt_cq34);
    // &>
  }
  reply.out() << _tntChunks[205]; // </div></div>\n
#line 620 "pageelems.ecpp"

}

  reply.out() << _tntChunks[206]; //           </div>\n          <div class="time">\n
#line 625 "pageelems.ecpp"
           if (!archived.empty()) {

  reply.out() << _tntChunks[207]; //               <span class="bold">
#line 626 "pageelems.ecpp"
  reply.sout() << ( (archived + " ") );
  reply.out() << _tntChunks[208]; // </span>\n
#line 627 "pageelems.ecpp"
           }

  reply.out() << _tntChunks[209]; //             
#line 628 "pageelems.ecpp"
  reply.sout() << ( (time) );
  reply.out() << _tntChunks[210]; // \n
#line 629 "pageelems.ecpp"
           if (!filename.empty() && !channel.empty()) {

  reply.out() << _tntChunks[211]; //               <div class="channel">
#line 630 "pageelems.ecpp"
  reply.sout() << ( (channel) );
  reply.out() << _tntChunks[212]; // </div>\n
#line 631 "pageelems.ecpp"
           }

  reply.out() << _tntChunks[213]; //           </div>\n          <div class="title">
#line 633 "pageelems.ecpp"
  reply.sout() << ( (title) );
  reply.out() << _tntChunks[214]; // </div>\n          <div class="short">
#line 634 "pageelems.ecpp"
  reply.sout() << ( (short_descr) );
  reply.out() << _tntChunks[215]; // </div>\n          <div class="description" id=
#line 635 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[216]; // _description>\n          <span id = "
#line 636 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[217]; // _epg_image" class="epg_images">\n
#line 637 "pageelems.ecpp"

  std::list<std::string> images = EpgEvents::EpgImages(boxId);
  for(std::list<std::string>::iterator it = images.begin(); it != images.end(); ++it ) {

  reply.out() << _tntChunks[218]; //          <a href="/epgimages/
#line 641 "pageelems.ecpp"
  reply.sout() << ( *it );
  reply.out() << _tntChunks[219]; // " target="_blank">\n            <img src="/epgimages/
#line 642 "pageelems.ecpp"
  reply.sout() << ( *it );
  reply.out() << _tntChunks[220]; // " class="epg_image"/>\n         </a>\n
#line 644 "pageelems.ecpp"
 } bool scraperImage = false;

#line 645 "pageelems.ecpp"
 if(!epgImage.empty() ) { scraperImage = true;

  reply.out() << _tntChunks[221]; //     <a href="/tvscraper/
#line 646 "pageelems.ecpp"
  reply.sout() << ( epgImage );
  reply.out() << _tntChunks[222]; // " target="_blank">\n      <img src="/tvscraper/
#line 647 "pageelems.ecpp"
  reply.sout() << ( epgImage );
  reply.out() << _tntChunks[223]; // " class="epg_image"/>\n    </a>\n
#line 649 "pageelems.ecpp"
 } if (episodeFound && !scraperMovieOrTv.episode.episodeImage.path.empty() ) { scraperImage = true;

  reply.out() << _tntChunks[224]; //     <a href="/tvscraper/
#line 650 "pageelems.ecpp"
  reply.sout() << ( scraperMovieOrTv.episode.episodeImage.path );
  reply.out() << _tntChunks[225]; // " target="_blank">\n      <img src="/tvscraper/
#line 651 "pageelems.ecpp"
  reply.sout() << ( scraperMovieOrTv.episode.episodeImage.path );
  reply.out() << _tntChunks[226]; // " class="epg_image"/>\n    </a>\n
#line 653 "pageelems.ecpp"

  }  // episodeFound && !scraperMovieOrTv.episode.episodeImage.path.empty()
  if (!scraperImage) {
    std::list<std::string> images1 = EpgEvents::RecImages(boxId, filename);
    size_t delimPos = boxId.find_last_of('_');
    std::string recId = (delimPos)?boxId.substr(delimPos+1):boxId;

    for(std::list<std::string>::iterator it = images1.begin(); it != images1.end(); ++it ) {

  reply.out() << _tntChunks[227]; //       <a href="/recimages/
#line 662 "pageelems.ecpp"
  reply.sout() << ( recId );
  reply.out() << _tntChunks[228]; // /
#line 662 "pageelems.ecpp"
  reply.sout() << ( *it );
  reply.out() << _tntChunks[229]; // " target="_blank">\n        <img src="/recimages/
#line 663 "pageelems.ecpp"
  reply.sout() << ( recId );
  reply.out() << _tntChunks[230]; // /
#line 663 "pageelems.ecpp"
  reply.sout() << ( *it );
  reply.out() << _tntChunks[231]; // " class="epg_image"/>\n      </a>\n
#line 665 "pageelems.ecpp"

    }
  }

  reply.out() << _tntChunks[232]; //           </span> 
  reply.out() << _tntChunks[233]; // \n\n
  reply.out() << _tntChunks[234]; // \n<div id = '
#line 672 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[235]; // _scraper' hidden>\n
#line 673 "pageelems.ecpp"

if (scraperMovieOrTv.found) {

  reply.out() << _tntChunks[236]; //   <div class="scraper_list">
#line 676 "pageelems.ecpp"
  reply.sout() << ( tr("Title:") );
  reply.out() << _tntChunks[237]; //          
#line 676 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.title ) );
  reply.out() << _tntChunks[238]; // </div>\n
#line 677 "pageelems.ecpp"

  if (!scraperMovieOrTv.originalTitle.empty() ) {

  reply.out() << _tntChunks[239]; //   <div class="scraper_list">
#line 680 "pageelems.ecpp"
  reply.sout() << ( tr("Original title:") );
  reply.out() << _tntChunks[240]; //  
#line 680 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.originalTitle ) );
  reply.out() << _tntChunks[241]; // </div>\n
#line 681 "pageelems.ecpp"

  }
  if (episodeFound) {

  reply.out() << _tntChunks[242]; //     <div class="scraper_list">
#line 685 "pageelems.ecpp"
  reply.sout() << ( tr("Episode:") );
  reply.out() << _tntChunks[243]; //  S
#line 685 "pageelems.ecpp"
  reply.sout() << ( cSv(cToSvInt(scraperMovieOrTv.episode.season )) );
  reply.out() << _tntChunks[244]; // E
#line 685 "pageelems.ecpp"
  reply.sout() << ( cSv(cToSvInt(scraperMovieOrTv.episode.number)) );
#line 685 "pageelems.ecpp"
  reply.sout() << (scraperMovieOrTv.episode.absoluteNumber?concat("A", cToSvInt(scraperMovieOrTv.episode.absoluteNumber)):"");
  reply.out() << _tntChunks[245]; //  
#line 685 "pageelems.ecpp"
  reply.sout() << ( scraperMovieOrTv.episode.name );
  reply.out() << _tntChunks[246]; // </div>\n    <div class="scraper_list">
#line 686 "pageelems.ecpp"
  reply.sout() << ( tr("Episode overview:") );
  reply.out() << _tntChunks[247]; //    
#line 686 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.episode.overview ) );
  reply.out() << _tntChunks[248]; // </div>\n
#line 687 "pageelems.ecpp"

    if (scraperMovieOrTv.episode.vote_average != 0 ) {

  reply.out() << _tntChunks[249]; //       <div class="scraper_list">
#line 690 "pageelems.ecpp"
  reply.sout() << ( tr("Episode vote average/count:") );
  reply.out() << _tntChunks[250]; //  
#line 690 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.episode.vote_average) );
  reply.out() << _tntChunks[251]; //  / 
#line 690 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.episode.vote_count ) );
  reply.out() << _tntChunks[252]; // </div>\n
#line 691 "pageelems.ecpp"

    }

  reply.out() << _tntChunks[253]; //     <div class="scraper_list">
#line 694 "pageelems.ecpp"
  reply.sout() << ( tr("Episode first aired:") );
  reply.out() << _tntChunks[254]; //  
#line 694 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.episode.firstAired ) );
  reply.out() << _tntChunks[255]; // </div>\n
#line 695 "pageelems.ecpp"
   if (scraperMovieOrTv.episode.runtime > 0) {

  reply.out() << _tntChunks[256]; //       <div class="scraper_list">
#line 696 "pageelems.ecpp"
  reply.sout() << ( tr("Episode runtime:") );
  reply.out() << _tntChunks[257]; //  
#line 696 "pageelems.ecpp"
  reply.sout() << ( FormatDuration(tr("%d:%02d"), scraperMovieOrTv.episode.runtime*60) );
  reply.out() << _tntChunks[258]; // </div>\n
#line 697 "pageelems.ecpp"
   }

#line 698 "pageelems.ecpp"
   if (!scraperMovieOrTv.episode.IMDB_ID.empty() ) {

  reply.out() << _tntChunks[259]; //       <a href="https://www.imdb.com/title/
#line 699 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.episode.IMDB_ID ) );
  reply.out() << _tntChunks[260]; // " target="_blank"> 
#line 699 "pageelems.ecpp"
  reply.sout() << ( tr("IMDB episode") );
  reply.out() << _tntChunks[261]; //  </a>\n
#line 700 "pageelems.ecpp"

    }
    bool charFound = false;
    for (const auto &character:scraperCharacters)
      if (character->getType() == eCharacterType::guestStar ||
          character->getType() == eCharacterType::writer ||
          character->getType() == eCharacterType::director) { charFound = true; break; }
    if (charFound) {

  reply.out() << _tntChunks[262]; //       <div class="scraper_list">
#line 709 "pageelems.ecpp"
  reply.sout() << ( tr("Guest stars and crew") );
  reply.out() << _tntChunks[263]; // </div>\n      <table>\n
#line 711 "pageelems.ecpp"
   for (const auto &character:scraperCharacters) {

#line 712 "pageelems.ecpp"
     if (character->getType() != eCharacterType::guestStar) continue;

  reply.out() << _tntChunks[264]; //       <tr>\n        <td class="cast_role"> 
#line 714 "pageelems.ecpp"
  reply.sout() << ( character->getCharacterName() );
  reply.out() << _tntChunks[265]; //  </td>\n        <td> 
#line 715 "pageelems.ecpp"
  reply.sout() << ( character->getPersonName() );
  reply.out() << _tntChunks[266]; //  </td>\n      </tr>\n
#line 717 "pageelems.ecpp"
   }

#line 718 "pageelems.ecpp"
   for (const auto &character:scraperCharacters) {

#line 719 "pageelems.ecpp"
     if (character->getType() != eCharacterType::writer) continue;

  reply.out() << _tntChunks[267]; //       <tr>\n        <td class="cast_role"> 
#line 721 "pageelems.ecpp"
  reply.sout() << ( tr("Writer") );
  reply.out() << _tntChunks[268]; //  </td>\n        <td> 
#line 722 "pageelems.ecpp"
  reply.sout() << ( character->getPersonName() );
  reply.out() << _tntChunks[269]; //  </td>\n      </tr>\n
#line 724 "pageelems.ecpp"
   }

#line 725 "pageelems.ecpp"
   for (const auto &character:scraperCharacters) {

#line 726 "pageelems.ecpp"
     if (character->getType() != eCharacterType::director) continue;

  reply.out() << _tntChunks[270]; //       <tr>\n        <td class="cast_role"> 
#line 728 "pageelems.ecpp"
  reply.sout() << ( tr("Director") );
  reply.out() << _tntChunks[271]; //  </td>\n        <td> 
#line 729 "pageelems.ecpp"
  reply.sout() << ( character->getPersonName() );
  reply.out() << _tntChunks[272]; //  </td>\n      </tr>\n
#line 731 "pageelems.ecpp"
   }

  reply.out() << _tntChunks[273]; //       </table>\n
#line 733 "pageelems.ecpp"

    }  // end if !episode.<Guest stars and crew>.empty()
  }  // end if episode found
  if (!scraperMovieOrTv.tagline.empty() ) {

  reply.out() << _tntChunks[274]; //   <div class="scraper_list">
#line 738 "pageelems.ecpp"
  reply.sout() << ( tr("Tagline:") );
  reply.out() << _tntChunks[275]; //         
#line 738 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.tagline ) );
  reply.out() << _tntChunks[276]; // </div>\n
#line 739 "pageelems.ecpp"
 }

  reply.out() << _tntChunks[277]; //   <div class="scraper_list">
#line 740 "pageelems.ecpp"
  reply.sout() << ( tr("Overview:") );
  reply.out() << _tntChunks[278]; //        
#line 740 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.overview ) );
  reply.out() << _tntChunks[279]; // </div>\n  <div class="scraper_list">
#line 741 "pageelems.ecpp"
  reply.sout() << ( tr("Genres:") );
  reply.out() << _tntChunks[280]; //          
#line 741 "pageelems.ecpp"
  reply.sout() << ( toString(scraperMovieOrTv.genres ) );
  reply.out() << _tntChunks[281]; // </div>\n
#line 742 "pageelems.ecpp"
 if (!scraperMovieOrTv.homepage.empty() ) {

  reply.out() << _tntChunks[282]; //   <div class="scraper_list"><a href ="
#line 743 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.homepage) );
  reply.out() << _tntChunks[283]; // " target="_blank">
#line 743 "pageelems.ecpp"
  reply.sout() << ( tr("Homepage") );
  reply.out() << _tntChunks[284]; // </a></div>\n
#line 744 "pageelems.ecpp"
 }

  reply.out() << _tntChunks[285]; //   <div class="scraper_list">
#line 745 "pageelems.ecpp"
  reply.sout() << ( tr("Release date:") );
  reply.out() << _tntChunks[286]; //    
#line 745 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.releaseDate ) );
  reply.out() << _tntChunks[287]; // </div>\n
#line 746 "pageelems.ecpp"
 if (scraperMovieOrTv.runtime > 0) {

  reply.out() << _tntChunks[288]; //   <div class="scraper_list">
#line 747 "pageelems.ecpp"
  reply.sout() << ( tr("Runtime:") );
  reply.out() << _tntChunks[289]; //         
#line 747 "pageelems.ecpp"
  reply.sout() << ( FormatDuration(tr("%d:%02d"), scraperMovieOrTv.runtime*60) );
  reply.out() << _tntChunks[290]; // </div>\n
#line 748 "pageelems.ecpp"
 }

#line 749 "pageelems.ecpp"

  if (scraperMovieOrTv.popularity != 0) {

  reply.out() << _tntChunks[291]; //   <div class="scraper_list">
#line 752 "pageelems.ecpp"
  reply.sout() << ( tr("Popularity:") );
  reply.out() << _tntChunks[292]; //      
#line 752 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.popularity ) );
  reply.out() << _tntChunks[293]; // </div>\n
#line 753 "pageelems.ecpp"

  }
  if (scraperMovieOrTv.voteAverage  != 0) {

  reply.out() << _tntChunks[294]; //   <div class="scraper_list">
#line 757 "pageelems.ecpp"
  reply.sout() << ( tr("Vote average/count:") );
  reply.out() << _tntChunks[295]; //  
#line 757 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.voteAverage ) );
  reply.out() << _tntChunks[296]; //  / 
#line 757 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.voteCount) );
  reply.out() << _tntChunks[297]; // </div>\n
#line 758 "pageelems.ecpp"

  }

  reply.out() << _tntChunks[298]; // \n
#line 764 "pageelems.ecpp"
 if (!scraperMovieOrTv.IMDB_ID.empty() ) {

  reply.out() << _tntChunks[299]; //     <div class="scraper_list">\n      <a href="https://www.imdb.com/title/
#line 766 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.IMDB_ID ) );
  reply.out() << _tntChunks[300]; // " target="_blank"> 
#line 766 "pageelems.ecpp"
  reply.sout() << ( tr("IMDB") );
  reply.out() << _tntChunks[301]; //  </a>\n    </div>\n
#line 768 "pageelems.ecpp"
 }

  reply.out() << _tntChunks[302]; // \n
#line 773 "pageelems.ecpp"

  if (scraperMovieOrTv.movie) {
    if (scraperMovieOrTv.budget) {

  reply.out() << _tntChunks[303]; //     <div class="scraper_list">
#line 777 "pageelems.ecpp"
  reply.sout() << ( tr("Budget:") );
  reply.out() << _tntChunks[304]; //          
#line 777 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.budget ) );
  reply.out() << _tntChunks[305]; // </div>\n
#line 778 "pageelems.ecpp"

    }
    if (scraperMovieOrTv.revenue) {

  reply.out() << _tntChunks[306]; //     <div class="scraper_list">
#line 782 "pageelems.ecpp"
  reply.sout() << ( tr("Revenue:") );
  reply.out() << _tntChunks[307]; //         
#line 782 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.revenue) );
  reply.out() << _tntChunks[308]; // </div>\n
#line 783 "pageelems.ecpp"

    }

  reply.out() << _tntChunks[309]; // \n
#line 789 "pageelems.ecpp"

    if (!scraperMovieOrTv.collectionName.empty() ) {

  reply.out() << _tntChunks[310]; //     <div class="scraper_list">
#line 792 "pageelems.ecpp"
  reply.sout() << ( tr("Collection name:") );
  reply.out() << _tntChunks[311]; //  
#line 792 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.collectionName) );
  reply.out() << _tntChunks[312]; // </div>\n
#line 793 "pageelems.ecpp"

    }
  } else {  // TV show

  reply.out() << _tntChunks[313]; //     <div class="scraper_list">
#line 797 "pageelems.ecpp"
  reply.sout() << ( tr("Status:") );
  reply.out() << _tntChunks[314]; //          
#line 797 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.status    ) );
  reply.out() << _tntChunks[315]; // </div>\n
  reply.out() << _tntChunks[316]; // \n
#line 801 "pageelems.ecpp"

  }
  bool charFound = false;
  for (const auto &character:scraperCharacters)
    if (character->getType() == eCharacterType::actor) { charFound = true; break; }
  if (!charFound && scraperMovieOrTv.movie) {
    for (const auto &character:scraperCharacters)
      if (character->getType() == eCharacterType::writer ||
          character->getType() == eCharacterType::director) { charFound = true; break; }
  }
  if (charFound) {

  reply.out() << _tntChunks[317]; //     <div class="scraper_list">
#line 813 "pageelems.ecpp"
  reply.sout() << ( tr("Cast and crew") );
  reply.out() << _tntChunks[318]; // </div>\n    <table>\n
#line 815 "pageelems.ecpp"
   for (const auto &character:scraperCharacters) {

#line 816 "pageelems.ecpp"
     if (character->getType() != eCharacterType::actor) continue;

  reply.out() << _tntChunks[319]; //       <tr>\n        <td class="cast_role"> 
#line 818 "pageelems.ecpp"
  reply.sout() << ( character->getCharacterName() );
  reply.out() << _tntChunks[320]; //  </td>\n        <td> 
#line 819 "pageelems.ecpp"
  reply.sout() << ( character->getPersonName() );
  reply.out() << _tntChunks[321]; //  </td>\n      </tr>\n
#line 821 "pageelems.ecpp"
   }

#line 822 "pageelems.ecpp"
   if (scraperMovieOrTv.movie) {

#line 823 "pageelems.ecpp"
     for (const auto &character:scraperCharacters) {

#line 824 "pageelems.ecpp"
       if (character->getType() != eCharacterType::writer) continue;

  reply.out() << _tntChunks[322]; //         <tr>\n          <td class="cast_role"> 
#line 826 "pageelems.ecpp"
  reply.sout() << ( tr("Writer") );
  reply.out() << _tntChunks[323]; //  </td>\n          <td> 
#line 827 "pageelems.ecpp"
  reply.sout() << ( character->getPersonName() );
  reply.out() << _tntChunks[324]; //  </td>\n        </tr>\n
#line 829 "pageelems.ecpp"
     }

#line 830 "pageelems.ecpp"
     for (const auto &character:scraperCharacters) {

#line 831 "pageelems.ecpp"
       if (character->getType() != eCharacterType::director) continue;

  reply.out() << _tntChunks[325]; //         <tr>\n          <td class="cast_role"> 
#line 833 "pageelems.ecpp"
  reply.sout() << ( tr("Director") );
  reply.out() << _tntChunks[326]; //  </td>\n          <td> 
#line 834 "pageelems.ecpp"
  reply.sout() << ( character->getPersonName() );
  reply.out() << _tntChunks[327]; //  </td>\n        </tr>\n
#line 836 "pageelems.ecpp"
     }

#line 837 "pageelems.ecpp"
   }

  reply.out() << _tntChunks[328]; //   </table>\n
#line 839 "pageelems.ecpp"

  }
}

  reply.out() << _tntChunks[329]; // </div>\n
  reply.out() << _tntChunks[330]; // \n<div id = '
#line 845 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[331]; // _actors' hidden>\n
#line 846 "pageelems.ecpp"

if (scraperMovieOrTv.found) {

  reply.out() << _tntChunks[332]; // <table>\n
#line 850 "pageelems.ecpp"

  const int num_cols = 4;
  int num = 1;
  std::string loc_name;
  getLanguage(loc_name, "LANGUAGE") ||
  getLanguage(loc_name, "LC_ALL") ||
  getLanguage(loc_name, "LC_MESSAGES") ||
  getLanguage(loc_name, "LANG");
  if (loc_name.empty() ) {
    loc_name = std::locale("").name().substr(0,2);
    if (loc_name.length() != 2 || loc_name[0] == 'C' || loc_name[0] == '*' || loc_name[0] == 'L') loc_name = "en"; //  use en as default
  }
  std::string actor_names = "";

  for (const auto &character:scraperCharacters) {
    if (character->getImage().path.empty() ) continue;  // only actors with images
    if (num == 1) {

  reply.out() << _tntChunks[333]; //       <tr>\n
#line 869 "pageelems.ecpp"
   }

  reply.out() << _tntChunks[334]; //     <td>\n      <a href="/tvscraper/
#line 871 "pageelems.ecpp"
  reply.sout() << ( character->getImage().path );
  reply.out() << _tntChunks[335]; // " target="_blank">\n        <img src="/tvscraper/
#line 872 "pageelems.ecpp"
  reply.sout() << ( character->getImage().path );
  reply.out() << _tntChunks[336]; // " alt="
#line 872 "pageelems.ecpp"
  reply.sout() << (character->getPersonName());
  reply.out() << _tntChunks[337]; // : 
#line 872 "pageelems.ecpp"
  reply.sout() << (character->getCharacterName());
  reply.out() << _tntChunks[338]; // " class="actor" />\n      </a>\n    </td>\n
#line 875 "pageelems.ecpp"

    stringAppend(actor_names, "<td><a href=\"https://", loc_name, ".wikipedia.org/wiki/",
      cToSvUrlEscaped(cToSvReplace(character->getPersonName(), " ", "_")), "\" target=\"_blank\">",
      character->getPersonName(), "</a>");
    actor_names.append(":<br>"); 
    actor_names.append(character->getCharacterName()); 
    actor_names.append("</td>"); 
    if (num == num_cols) {

  reply.out() << _tntChunks[339]; //       </tr>\n      <tr>
#line 885 "pageelems.ecpp"
  reply.out() << (actor_names);
  reply.out() << _tntChunks[340]; // </tr>\n
#line 886 "pageelems.ecpp"

      num = 0;
      actor_names = "";
    }
    num++;
  } // for character in scraperCharacters
  if (num != 1) {

  reply.out() << _tntChunks[341]; //     </tr>\n    <tr>
#line 895 "pageelems.ecpp"
  reply.out() << (actor_names);
  reply.out() << _tntChunks[342]; // </tr>\n
#line 896 "pageelems.ecpp"

  }

  reply.out() << _tntChunks[343]; // </table>\n
#line 900 "pageelems.ecpp"

}

  reply.out() << _tntChunks[344]; // </div>\n
  reply.out() << _tntChunks[345]; // \n<div id = '
#line 905 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[346]; // _artwork' hidden>\n
#line 906 "pageelems.ecpp"

  const uintptr_t media_p = (uintptr_t)&(scraperMovieOrTv.posters);
  const uintptr_t media_b = (uintptr_t)&(scraperMovieOrTv.banners);
  const uintptr_t media_f = (uintptr_t)&(scraperMovieOrTv.fanarts);

  // <& media ...
  { 
#line 911 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq35;
#line 911 "pageelems.ecpp"
    _tnt_cq35.add( "media_p", (media_p));
#line 911 "pageelems.ecpp"
  main().media(request, reply, _tnt_cq35);
    // &>
  }
  reply.out() << _tntChunks[347]; // \n
  // <& media ...
  { 
#line 912 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq36;
#line 912 "pageelems.ecpp"
    _tnt_cq36.add( "media_p", (media_f));
#line 912 "pageelems.ecpp"
  main().media(request, reply, _tnt_cq36);
    // &>
  }
  reply.out() << _tntChunks[348]; // \n
  // <& media ...
  { 
#line 913 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq37;
#line 913 "pageelems.ecpp"
    _tnt_cq37.add( "media_p", (media_b));
#line 913 "pageelems.ecpp"
  main().media(request, reply, _tnt_cq37);
    // &>
  }
  reply.out() << _tntChunks[349]; // \n</div>\n
  reply.out() << _tntChunks[350]; // \n<div id = '
#line 916 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[351]; // _epg'>\n
#line 917 "pageelems.ecpp"

{
  cToSvConcat long_descr_html_esc;
  AppendHtmlEscapedAndCorrectNonUTF8(long_descr_html_esc, long_descr);
  reply.out() << long_descr_html_esc;
}
const char *br_after_long_desc = "<br><br>";
if (long_descr.empty()) br_after_long_desc = "";

if (epgEvent) {
  bool first = true;
  for (int i = 0; epgEvent->Contents(i); i++) {
    const char *s = cEvent::ContentToString(epgEvent->Contents(i));
    if (!isempty(s)) {
      if (first) {
        first = false;

  reply.out() << _tntChunks[352]; //  
#line 934 "pageelems.ecpp"
  reply.out() << (br_after_long_desc);
  reply.out() << _tntChunks[353]; // \n 
#line 935 "pageelems.ecpp"
  reply.sout() << (tr("Content"));
  reply.out() << _tntChunks[354]; // :\n
#line 936 "pageelems.ecpp"
     } else { reply.out() << ","; }

  reply.out() << _tntChunks[355]; //  
#line 937 "pageelems.ecpp"
  reply.sout() << (s);
#line 937 "pageelems.ecpp"

    }
  }
  if (epgEvent->ParentalRating()) {
    if (first) reply.out() << br_after_long_desc;
    else reply.out() << "<br>";

  reply.out() << _tntChunks[356]; //    
#line 944 "pageelems.ecpp"
  reply.sout() << (tr("Parental rating"));
  reply.out() << _tntChunks[357]; // : 
#line 944 "pageelems.ecpp"
  reply.sout() << (cToSvFormated(trVDR("ParentalRating$from %d"), epgEvent->ParentalRating()) );
  reply.out() << _tntChunks[358]; // \n
#line 945 "pageelems.ecpp"

  }
}

  reply.out() << _tntChunks[359]; //         </div>\n      </div>\n    </div>\n  </div>\n</div>\n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::media_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::media " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
uintptr_t media_p = qparam.get< uintptr_t >("media_p");
  // </%args>

#line 47 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 961 "pageelems.ecpp"

const std::vector<cTvMedia> *media_v = static_cast<std::vector<cTvMedia> *>((void *)media_p);
for (const cTvMedia &media: *media_v) {

  reply.out() << _tntChunks[362]; //   <a href="/tvscraper/
#line 965 "pageelems.ecpp"
  reply.sout() << ( media.path );
  reply.out() << _tntChunks[363]; // " target="_blank">\n    <img src="/tvscraper/
#line 966 "pageelems.ecpp"
  reply.sout() << ( media.path );
  reply.out() << _tntChunks[364]; // " class="artwork" />\n  </a>\n
#line 968 "pageelems.ecpp"

}

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::about_tt_box_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::about_tt_box " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 47 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
  reply.out() << _tntChunks[366]; //   <div class="epg_description" id="aboutBox">\n    <div class="station">\n      <div class="boxheader"><div><div class="caption">
#line 977 "pageelems.ecpp"
  reply.sout() << ( tr(LIVESUMMARY) );
  reply.out() << _tntChunks[367]; // </div></div></div>\n    </div>\n    <div class="epg_content">\n      <div>\n        <div class="about_head"><div><div>
#line 981 "pageelems.ecpp"
  reply.sout() << ( tr("Authors") );
  reply.out() << _tntChunks[368]; // </div></div></div>\n        <div class="about_left">
#line 982 "pageelems.ecpp"
  reply.sout() << ( tr("Project Idea") );
  reply.out() << _tntChunks[369]; // :</div>\n        <div class="about_right">Thomas Keil (Thomas)</div>\n        <div class="about_left">
#line 984 "pageelems.ecpp"
  reply.sout() << ( tr("Webserver") );
  reply.out() << _tntChunks[370]; // :</div>\n        <div class="about_right">Sascha Volkenandt (LordJaxom)</div>\n        <div class="about_left">
#line 986 "pageelems.ecpp"
  reply.sout() << ( tr("Current Maintainer") );
  reply.out() << _tntChunks[371]; // :</div>\n        <div class="about_right">Markus Ehrnsperger (MarkusE @ <a href="https://www.vdr-portal.de">VDR Portal</a>)</div>\n        <div class="about_left">
#line 988 "pageelems.ecpp"
  reply.sout() << ( tr("Previous Maintainer") );
  reply.out() << _tntChunks[372]; // :</div>\n        <div class="about_right">Jasmin Jessich (jasminj)</div>\n        <div class="about_left">
#line 990 "pageelems.ecpp"
  reply.sout() << ( tr("Project leader") );
  reply.out() << _tntChunks[373]; // :</div>\n        <div class="about_right">Dieter Hametner (tadi)</div>\n        <div class="about_left">
#line 992 "pageelems.ecpp"
  reply.sout() << ( tr("Content") );
  reply.out() << _tntChunks[374]; // :</div>\n        <div class="about_right">Christian Wieninger (winni)</div>\n        <div class="about_left">
#line 994 "pageelems.ecpp"
  reply.sout() << ( tr("Graphics") );
  reply.out() << _tntChunks[375]; // :</div>\n        <div class="about_right">Michael Br&uuml;ckner (skiller2k1)</div>\n        <div class="about_head"><div><div>
#line 996 "pageelems.ecpp"
  reply.sout() << ( tr("Information") );
  reply.out() << _tntChunks[376]; // </div></div></div>\n        <div class="about_left">
#line 997 "pageelems.ecpp"
  reply.sout() << ( tr("LIVE version") );
  reply.out() << _tntChunks[377]; // :</div>\n        <div class="about_right">
#line 998 "pageelems.ecpp"
  reply.sout() << ( LIVEVERSION );
#line 998 "pageelems.ecpp"
  reply.sout() << ( VERSION_SUFFIX );
  reply.out() << _tntChunks[378]; // </div>\n        <div class="about_left">
#line 999 "pageelems.ecpp"
  reply.sout() << ( tr("VDR version") );
  reply.out() << _tntChunks[379]; // :</div>\n        <div class="about_right">
#line 1000 "pageelems.ecpp"
  reply.sout() << ( VDRVERSION );
  reply.out() << _tntChunks[380]; // </div>\n        <div class="about_head"><div><div>
#line 1001 "pageelems.ecpp"
  reply.sout() << ( tr("Features") );
  reply.out() << _tntChunks[381]; // </div></div></div>\n        <div class="about_left">EPGsearch:</div>\n        <div class="about_right">\n
#line 1004 "pageelems.ecpp"
          Features< features::epgsearch >& epgsearch = LiveFeatures< features::epgsearch >();

  reply.out() << _tntChunks[382]; //           <img align="center" src="
#line 1005 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", epgsearch.Recent() ? "active.png" : "inactive.png") );
  reply.out() << _tntChunks[383]; // "/>\n
#line 1006 "pageelems.ecpp"
          if ( epgsearch.Recent() ) {

  reply.out() << _tntChunks[384]; //             
#line 1007 "pageelems.ecpp"
  reply.sout() << ( tr("active") );
  reply.out() << _tntChunks[385]; // : 
#line 1007 "pageelems.ecpp"
  reply.sout() << ( epgsearch.Version() );
  reply.out() << _tntChunks[386]; // \n
#line 1008 "pageelems.ecpp"
          } else {

  reply.out() << _tntChunks[387]; //             
#line 1009 "pageelems.ecpp"
  reply.sout() << ( tr("required") );
  reply.out() << _tntChunks[388]; // : 
#line 1009 "pageelems.ecpp"
  reply.sout() << ( epgsearch.MinVersion() );
  reply.out() << _tntChunks[389]; // \n
#line 1010 "pageelems.ecpp"
          }

  reply.out() << _tntChunks[390]; //           (<a href="https://github.com/vdr-projects/vdr-plugin-epgsearch" target="_blank">
#line 1011 "pageelems.ecpp"
  reply.sout() << ( tr("Homepage") );
  reply.out() << _tntChunks[391]; // </a>)<br/>\n        </div>\n        <div class="about_left">Streamdev server:</div>\n        <div class="about_right">\n
#line 1015 "pageelems.ecpp"

          Features< features::streamdev_server >& streamdev = LiveFeatures< features::streamdev_server >();

  reply.out() << _tntChunks[392]; //           <img align="center" src="
#line 1018 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", streamdev.Loaded() ? "active.png" : "inactive.png") );
  reply.out() << _tntChunks[393]; // "/>\n
#line 1019 "pageelems.ecpp"

          if ( streamdev.Loaded() ) {

  reply.out() << _tntChunks[394]; //             
#line 1022 "pageelems.ecpp"
  reply.sout() << ( tr("active") );
  reply.out() << _tntChunks[395]; // : 
#line 1022 "pageelems.ecpp"
  reply.sout() << ( streamdev.Version() );
  reply.out() << _tntChunks[396]; // \n
#line 1023 "pageelems.ecpp"

          } else {

  reply.out() << _tntChunks[397]; //             
#line 1026 "pageelems.ecpp"
  reply.sout() << ( tr("required") );
  reply.out() << _tntChunks[398]; // : 
#line 1026 "pageelems.ecpp"
  reply.sout() << ( streamdev.MinVersion() );
  reply.out() << _tntChunks[399]; // \n
#line 1027 "pageelems.ecpp"

          }

  reply.out() << _tntChunks[400]; //           (<a href="https://github.com/vdr-projects/vdr-plugin-streamdev" target="_blank">
#line 1030 "pageelems.ecpp"
  reply.sout() << ( tr("Homepage") );
  reply.out() << _tntChunks[401]; // </a>)<br/>\n        </div>\n        <div class="about_left">tvscraper:</div>\n        <div class="about_right">\n
#line 1034 "pageelems.ecpp"
          Features< features::tvscraper >& tvscraper = LiveFeatures< features::tvscraper >();

  reply.out() << _tntChunks[402]; //           <img align="center" src="
#line 1035 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", tvscraper.Recent() ? "active.png" : "inactive.png") );
  reply.out() << _tntChunks[403]; // "/>\n
#line 1036 "pageelems.ecpp"
          if ( tvscraper.Recent() ) {

  reply.out() << _tntChunks[404]; //             
#line 1037 "pageelems.ecpp"
  reply.sout() << ( tr("active") );
  reply.out() << _tntChunks[405]; // : 
#line 1037 "pageelems.ecpp"
  reply.sout() << ( tvscraper.Version() );
  reply.out() << _tntChunks[406]; // \n
#line 1038 "pageelems.ecpp"
          } else {

  reply.out() << _tntChunks[407]; //             
#line 1039 "pageelems.ecpp"
  reply.sout() << ( tr("required") );
  reply.out() << _tntChunks[408]; // : 
#line 1039 "pageelems.ecpp"
  reply.sout() << ( tvscraper.MinVersion() );
  reply.out() << _tntChunks[409]; // \n
#line 1040 "pageelems.ecpp"
          }

  reply.out() << _tntChunks[410]; //           (<a href="https://github.com/MarkusEh/vdr-plugin-tvscraper" target="_blank">
#line 1041 "pageelems.ecpp"
  reply.sout() << ( tr("Homepage") );
  reply.out() << _tntChunks[411]; // </a>)<br/>\n        </div>\n        <div class="about_head"><div><div>
#line 1043 "pageelems.ecpp"
  reply.sout() << ( tr("Information providers") );
  reply.out() << _tntChunks[412]; // </div></div></div>\n        <div class="about_line">Movie information provided by <a target="_blank" href="https://www.themoviedb.org/">TMDB</a>. This product uses the TMDB API but is not endorsed or certified by TMDB.</div>\n        <div class="about_line">Information provided by TheTVDB.com. Please consider <a target="_blank" href="https://u10505776.ct.sendgrid.net/ls/click\?upn=xMYYCP13hVd-2BZPpbVcMPHeLXfv-2BPRdIsKm2qSeirIHi7kH9am8IxD-2BavFbeqGqIXIcjH_INgc0CXRkIvGU-2BJ1W6HLAynNbR0UBoMb2tkpDdezO3QRj-2FQPQAMrtJKVcB0N7eSvbYpjQTDNOQBf2pb94uDgGr0-2BXyXFk7Oyfva30BASYCRLvtRQyi5eOCAbH8fon7UETlPydobeLA3Recu9OsXol8c7Ng4pDAsH6KsFF8CH7HQoVxivnpKrQW2v4ek7U-2BYlWmH31o9Koke3vq-2FDsQ0P-2BiKLECU3LgttsntUcN8fnUs-3D">supporting them.</a></div>\n        <div class="about_head"><div><div>
#line 1046 "pageelems.ecpp"
  reply.sout() << ( tr("Bugs and suggestions") );
  reply.out() << _tntChunks[413]; // </div></div></div>\n        <div class="about_line">
#line 1047 "pageelems.ecpp"
  reply.sout() << ( tr("If you encounter any bugs or would like to suggest new features, please use our bugtracker") );
  reply.out() << _tntChunks[414]; // :<br/>\n          <a target="_blank" href="https://github.com/MarkusEh/vdr-plugin-live/issues">https://github.com/MarkusEh/vdr-plugin-live/issues</a></div>\n        <div class="about_head"><div><div>&nbsp;</div></div></div>\n      </div>\n    </div>\n  </div>\n
  // <%/cpp>
  return DEFAULT;
}

} // namespace
