////////////////////////////////////////////////////////////////////////
// recordings.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.recordings")

// <%pre>
#line 1 "recordings.ecpp"


#include <string>
#include <string_view>
#include <setup.h>
#include <tools.h>
#include <users.h>
#include <recman.h>
#include <tntconfig.h>
#include <vdr/channels.h>
#include <stringhelpers.h>
#include <livefeatures.h>

#include <vdr/videodir.h>

#define MB_PER_MINUTE 25.75 // this is just an estimate!

using namespace vdrlive;


#line 1 "page_init.eh"

// do not add to Makefile
// and do not write a ecpp comment into this file. It must produce no
// HTML output not even an empty line.
#include <tnt/savepoint.h>
#include <exception.h>

#line 2 "page_exit.eh"

#include <exception.h>

// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    class recordings_item_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        recordings_item_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class sort_options_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        sort_options_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class setactive_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        setactive_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class del_rec_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        del_rec_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class edit_rec_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        edit_rec_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class todel_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        todel_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class rec_tools_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        rec_tools_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class archived_disc_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        archived_disc_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class delete_error_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        delete_error_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    recordings_item_type recordings_item;
    sort_options_type sort_options;
    setactive_type setactive;
    del_rec_type del_rec;
    edit_rec_type edit_rec;
    todel_type todel;
    rec_tools_type rec_tools;
    archived_disc_type archived_disc;
    delete_error_type delete_error;
};

static tnt::EcppComponentFactoryImpl<_component_> Factory("recordings");

static const char* rawData = "$\003\000\000%\003\000\000&\003\000\000'\003\000\000\231\003\000\000\246\003\000\000\253"
  "\003\000\000\260\003\000\000\333\003\000\000\016\005\000\000\026\005\000\000\034\005\000\000.\005\000\000v\005\000"
  "\000%\006\000\000-\006\000\0003\006\000\000E\006\000\000N\006\000\000z\006\000\0001\007\000\000`\007\000\000{\007\000"
  "\000\215\007\000\000\232\010\000\000\247\010\000\000\263\010\000\000\306\010\000\000s\t\000\000t\t\000\000v\t\000\000"
  "w\t\000\000y\t\000\000z\t\000\000\266\t\000\000\311\t\000\000\317\t\000\000\320\t\000\000\226\n\000\000\346\n\000\000"
  "\033\013\000\000N\013\000\000\215\013\000\000\347\013\000\000\361\013\000\000\017\014\000\000(\014\000\000)\014\000"
  "\000*\014\000\000,\014\000\000\216\014\000\000\261\014\000\000\006\015\000\0007\015\000\000\205\015\000\000\343\015"
  "\000\000\t\016\000\000t\016\000\000\217\016\000\000\313\016\000\000\363\016\000\000\000\017\000\000@\017\000\000{\017"
  "\000\000\234\017\000\000\247\017\000\000\254\017\000\000\257\017\000\000\263\017\000\000\300\017\000\000\341\017\000"
  "\000\371\017\000\000\010\020\000\000+\020\000\000-\020\000\0001\020\000\0007\020\000\000K\020\000\000Q\020\000\000S"
  "\020\000\000W\020\000\000[\020\000\000o\020\000\000\200\020\000\000\205\020\000\000\210\020\000\000\212\020\000\000"
  "\232\020\000\000\374\020\000\000Z\021\000\000\270\021\000\000\014\022\000\000N\022\000\000\254\022\000\000\272\022"
  "\000\000\362\022\000\000\363\022\000\000\364\022\000\000\015\023\000\0004\023\000\000<\023\000\000B\023\000\000D\023"
  "\000\000F\023\000\000\204\023\000\000\214\023\000\000\222\023\000\000\224\023\000\000\226\023\000\000\346\023\000\000"
  "\354\023\000\000\356\023\000\000\360\023\000\000\365\023\000\000.\024\000\0006\024\000\000<\024\000\000>\024\000\000"
  "\?\024\000\000D\024\000\000x\024\000\000\247\024\000\000\327\024\000\000\333\024\000\000\347\024\000\000\357\024\000"
  "\000*\025\000\0003\025\000\000X\025\000\000a\025\000\000d\025\000\000k\025\000\000l\025\000\000m\025\000\000{\025\000"
  "\000|\025\000\000}\025\000\000\235\025\000\000\243\025\000\000\253\025\000\000\261\025\000\000\303\025\000\000\305"
  "\025\000\000\320\025\000\000\337\025\000\000\340\025\000\000\341\025\000\000\004\026\000\000\n\026\000\000\022\026"
  "\000\000\030\026\000\000*\026\000\0006\026\000\000\?\026\000\000F\026\000\000G\026\000\000H\026\000\000z\026\000\000"
  "\221\026\000\000\266\026\000\000\006\027\000\000q\027\000\000\263\027\000\0002\030\000\000D\030\000\000\206\030\000"
  "\000\276\030\000\000\301\030\000\000\304\030\000\000\373\030\000\000\211\031\000\000\272\031\000\000\372\031\000\000"
  "\375\031\000\0000\032\000\0002\032\000\0003\032\000\0004\032\000\0005\032\000\0006\032\000\0007\032\000\0008\032\000"
  "\0009\032\000\000~\032\000\000\300\032\000\000\303\032\000\000\305\032\000\000\310\032\000\000\314\032\000\000\320"
  "\032\000\000\323\032\000\000\326\032\000\000\343\032\000\000\344\032\000\000\356\032\000\000\375\032\000\000\001\033"
  "\000\000\002\033\000\000\003\033\000\000\004\033\000\000\005\033\000\000\n\n\n\n<html>\n  <head>\n    <meta name=\"vi"
  "ewport\" content=\"width=device-width, initial-scale=1\" />\n    <title>VDR-Live - </title>\n    \n    \n    \n<scrip"
  "t>\nconst recordings_tree_creation = ;\nconst recs = [];\nconst rec_ids = Object.create(null)\nrec_ids[\"T\"] = [1, 2"
  "]\n\n// Title is the title of the action (like \"play in media player\"), and will be html encoded here\nfunction Rec"
  "ordingActionS(s, id, A, Img, Title) {\n  s.a += '<a href=\"'\n  s.a += A\n  s.a += 'recording_'\n  s.a += id\n  s.a +"
  "= '&sort=&filter=&flat=&history_num_back=\" title=\"'\n  addEncodeHtml(s, Title)\n  s.a += '\"><img class=\"icon\" sr"
  "c=\"'\n  s.a += Img\n  s.a += '\" /></a>'\n}\nfunction RecordingActionPlaylist(s, id) {\n  s.a += '<a class=\"hidden-"
  "xs\" href=\"playlist.m3u\?recid=recording_'\n  s.a += id\n  s.a += '&sort=&filter=&flat=&history_num_back=\" title=\""
  "\" download><img class=\"icon hidden-xs\" src=\"playlist.png\" /></a>'\n}\n\n// do not html encode title! will be htm"
  "l encoded here\nfunction addEventRec_r(s, eventid, title, folder, shortText, description) {\n  var http_params = '&so"
  "rt=&filter='\n  http_params += encodeURIComponent('')\n  http_params += '&flat=&history_num_back='\n  addEventRec(s, "
  "'recording_', eventid, http_params, title, folder, shortText, description)\n}\n</script>\n<script type=\"text/javascr"
  "ipt\" src=\"js.html\"></script>\n\n  <script type=\"text/javascript\" src=\"js/live/treeview.js\"></script>\n  <scrip"
  "t>\n  const tv = new Treeview(\"minus.png\", \"plus.png\", \"folder_open.png\", \"folder_closed.png\");\n  </script>"
  "\n</head>\n<body onload=\"adjustHeader()\" onresize=\"adjustHeader()\" onpageshow=\"clearCheckboxes(document.getEleme"
  "ntById('form_recordings'))\">\n  \n  \n  \n  <div class=\"inhalt\">\n    <div class=\"boxheader\"><div><div></div></d"
  "iv></div>\n      \n      <form method=\"post\" name=\"recordings\" id=\"form_recordings\" action=\"recordings.ecpp\">"
  "\n        <div class=\"recordings\">\n          <ul class=\"recordingslist\" style=\"display: block;\">\n            "
  "\n          </ul>\n        </div>\n        <input type=\"hidden\" name=\"sort\" value=\"\">\n        <input type=\"hi"
  "dden\" name=\"filter\" value=\"\">\n        <input type=\"hidden\" name=\"flat\" value=\"\">\n        <input type=\"h"
  "idden\" name=\"history_num_back\" value=\"\">\n        <div class=\"withmargin hidden-xs\">\n          <button class="
  "\"red\" type=\"submit\"></button>\n\n        </div>\n      </form>\n  </div>\n</body>\n</html>\n\n\n\n\n      <li cla"
  "ss=\"recording\">\n        <div class=\"recording_item\" onclick = \"tv.Toggle(this, 'fldr_')\">\n        <table><tr>"
  "\n                      <td class = \"space\">\n              <img src=\"img/transparent.png\" width=\"px\" height=\""
  "16px\" />\n            </td>\n                    <td class=\"space\">\n            <img class=\"recording_expander\""
  " src=\"plus.png\" />\n          </td><td class=\"space\">\n            <img class=\"recording_folder\" src=\"folder_c"
  "losed.png\" />\n          </td>\n            <td class = space>\n              <div class=\"thumb\">\n               "
  " <img data-src=\"/tvscraper/\"\n                  class=\"\"\n                />\n              </div>\n            <"
  "/td>\n        <td class=\"recording_folder_name\">\n          \n        </td></tr></table>\n        </div>\n        <"
  "ul id=\"fldr_\" class=\"recordingslist\" style=\"display: none;\">\n          \n        </ul>\n      </li>\n      <sc"
  "ript>\n  recs[]=[]\n  \n</script>\n      <script>\n      rec_ids[\"fldr_\"] = []\n    </script>\n        <script>\n  "
  "    document.write(rec_string_d([, , [  ]]))\n      rec_ids[\"fldr_\"] = [, , [  ]]\n      </script>\n    <script>\n "
  "       recs[]=[]\n</script>\n            <li class=\"recording\">\n        <div class=\"recording_item\" onclick = \""
  "tv.Toggle(this, 'fldr_')\">\n          <table><tr><td class=\"space\">\n            <img class=\"recording_expander\""
  " src=\"plus.png\" />\n          </td><td class=\"space\">\n            <img class=\"recording_folder\" src=\"folder_c"
  "losed.png\" />\n          </td><td class=\"recording_folder_name\">\n            \n          </td></tr></table>\n    "
  "    </div>\n        <ul id=\"fldr_\" class=\"recordingslist\" style=\"display: none;\">\n          <script>\n        "
  "    rec_ids[\"fldr_\"] = [1, 1, [  ]]\n          </script>\n        </ul>\n      </li>\n      \n\n<span class=\"label"
  " bold\"> </span>\n<a href=\"recordings.html\?sort=&filter=&flat=\"  ></a>\n<span class=\"sep\">|</span>\n<a href=\"re"
  "cordings.html\?sort=&filter=&flat=\"  ></a>\n<span class=\"sep\">|</span>\n<a href=\"recordings.html\?sort=duplicates"
  "&filter=&flat=\"  ></a>\n<span class=\"sep\">|</span>\n<a href=\"recordings.html\?sort=&filter=&flat=\" ></a>\n<span "
  "class=\"sep\">|</span>\n<span class=\"label bold\">:&nbsp;<input type=\"text\" name=\"filter\" value=\"\" id=\"filter"
  "\" onchange=\"filterRecordings(this, '', '')\" />&nbsp;</span>\n<span class=\"sep\">|</span>\n<img onclick=\"ExpandAl"
  "l()\" src=\"\" alt=\"\" />\n<img onclick=\"CollapseAll()\" src=\"\" alt=\"\" />\n<br />\n\n\nclass=\"active\"\n\n<a h"
  "ref=\"epginfo.html\?epgid=del_&sort=&filter=&flat=&history_num_back=\" ><img src=\"\" alt=\"\" /></a>\n\n<a href=\"ed"
  "it_recording.html\?recid=&sort=&filter=&flat=&history_num_back=\"><img src=\"\" alt=\"\"  /></a>\n\n<!DOCTYPE html>\n"
  "<html>\n  <script>\n    history.go(-);\n  </script>\n</html>\n<div class=\"epg_description\" id=\"del_\">\n  <div cla"
  "ss=\"station\">\n    <div class=\"boxheader\"><div><div class=\"caption\"></div></div></div>\n  </div>\n  <div class="
  "\"epg_content\">\n    <form>\n      <div class=\"about_head\"><div><div></div></div></div>\n      <input type=\"hidde"
  "n\" name=\"epgid\" value=\"\" >\n      <input type=\"hidden\" name=\"delete_rec\" value=\"confirmed\" >\n      <input"
  " type=\"hidden\" name=\"history_num_back\" value=\"\" id=\"history_del_\">\n      <div class=\"about_left\">\n       "
  " <button id=\"confirm_del_\" class=\"green\" type=\"button\" onclick=\"delete_rec_back('', )\"></button>\n      </div"
  ">\n      <div class=\"about_right\">\n\n<script>\nfunction cancel_delete() {\n  if (document.referrer.indexOf(\"epgin"
  "fo.html\?\") != -1) {\n    history.go(-1);\n  } else {\n    history.go(-);\n  }\n}\n</script>\n        <button id=\"c"
  "lose_del_\" type=\"button\" class=\"red\" onclick=\"back_depending_referrer(1, )\"></button>\n      </div>\n    </for"
  "m>\n  </div>\n</div>\n\n\n\n\n\n\n\n\n\n<img data-src=\"img/transparent.png\" height=\"10px\" />\n<span id=\"icons-\""
  "></span>\n<script class=\"injectIcons\">\ninjectErrorHdSdIcon(\"icons-\", , , \"\", \"\", \"\", , \"\")\n</script>\n"
  "\n<img src=\"\" alt=\"on_dvd\"  />\n\n\n\n\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl),
    recordings_item(*this, "recordings_item"),
    sort_options(*this, "sort_options"),
    setactive(*this, "setactive"),
    del_rec(*this, "del_rec"),
    edit_rec(*this, "edit_rec"),
    todel(*this, "todel"),
    rec_tools(*this, "rec_tools"),
    archived_disc(*this, "archived_disc"),
    delete_error(*this, "delete_error")
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

template <typename T>
inline void _tnt_ignore_unused(const T&) { }

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings " << qparam.getUrl());

  tnt::DataChunks _tntChunks(rawData);

  // <%args>
std::string sort = qparam.get< std::string >("sort");
std::string todel = qparam.get< std::string >("todel");
std::string diskinfo = qparam.get< std::string >("diskinfo");
std::string filter = qparam.get< std::string >("filter");
std::vector< std::string > deletions = qparam.getvector< std::string >("deletions");
std::string flat = qparam.get< std::string >("flat");
int history_num_back = qparam.get< int >("history_num_back", ( 0));
  // </%args>

#line 31 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 36 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 37 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 38 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 39 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  reply.out() << _tntChunks[0]; // \n
  reply.out() << _tntChunks[1]; // \n
  reply.out() << _tntChunks[2]; // \n
  // <%include> page_init.eh
#line 11 "page_init.eh"

try {
  reply.setHeader("Expires", "Mon, 26 Jul 1997 05:00:00 GMT");
  tnt::Savepoint spoint( reply );

  // </%include>
#line 43 "recordings.ecpp"

std::chrono::time_point<std::chrono::high_resolution_clock> timeStart = std::chrono::high_resolution_clock::now();

reply.setHeader (tnt::httpheader::cacheControl, "no-store, no-cache, max-age=0, must-revalidate, proxy-revalidate", true);
if (!logged_in && LiveSetup().UseAuth()) {
  cToSvConcat<0> targetUrl = "/login.html?redirect=";
  targetUrl.appendUrlEscaped(request.getQuery());
  return reply.redirect(targetUrl.data());
}

if (request.getMethod() != "POST") history_num_back = 0;  // we can go back in history to this page
else ++history_num_back;  // we have to go back in history to a prev page, to avoid re-send of form data

// create the "current" values of the global request parameters, based on their old values and the current arguments
// basically, this is a bad idea. Pushing "refresh" changes the sort order :( .
// Better: Urls on menue have parameters depending on the current sort option
if (! flat.empty() ) currentFlat = flat;
// sort depends on old sort, and sort parameter
currentSort = LiveSetup().GetLastSortingMode();
if (currentSort.empty() ) currentFlat == "true"?currentSort = "errorsts":currentSort = "datedesc";
if (!sort.empty()) {
  if (sort == "date")
    currentSort = (currentSort == "datedesc") ? "dateasc" : "datedesc";
  else if (sort == "datedesc" || sort == "dateasc") currentSort = sort;
  else if (sort == "name")
    currentSort = (currentSort == "nameasc") ? "namedesc" : "nameasc";
  else if (sort == "nameasc" || sort == "namedesc") currentSort = sort;
  else if (sort == "errors")
    currentSort = (currentSort == "errorsts") ? "errorsdur" : "errorsts";
  else if (sort == "errorsts" || sort == "errorsdur") currentSort = sort;
  else if (sort == "duplicates")
    currentSort = sort;
  LiveSetup().SetLastSortingMode(currentSort);
}
currentFilter = filter;

pageTitle = tr("Recordings");

if (!todel.empty()) {
  if (!cUser::CurrentUserHasRightTo(UR_DELRECS))
    throw HtmlError( tr("Sorry, no permission. Please contact your administrator!") );
  deletions.push_back(todel);
}

deleteResult = "";
if (cUser::CurrentUserHasRightTo(UR_DELRECS)) {
  for (auto it = deletions.begin(); it != deletions.end(); ++it) {
    std::string name;
    if (RecordingsManager::DeleteRecording(*it, &name) == 0) {
      cToSvConcat delRec(tr("Deleted recording:"), " ");
      delRec.appendReplace(name, "~", "/");
      delRec << "<br/>";
      deleteResult += std::string(delRec);
    }
  }
  deletions.clear();
} else {
  throw HtmlError( tr("Sorry, no permission. Please contact your administrator!") );
}

int FreeMB, UsedMB;
int Percent = cVideoDirectory::VideoDiskSpace(&FreeMB, &UsedMB);
int Minutes = int(double(FreeMB) / MB_PER_MINUTE);
int Hours = Minutes / 60;
Minutes %= 60;
diskinfo = cString::sprintf("%s %d%%  -  %2d:%02d %s", trVDR("Disk"), Percent, Hours, Minutes, trVDR("free"));

RecordingsTreePtr recordingsTree(RecordingsManager::GetRecordingsTree());

// get data for all open nodes
std::vector<int> available_recs;
std::string openTreeNodes;
if (request.hasCookie("VDR-Live-Recordings-Tree-Open-Nodes")) {
  openTreeNodes = request.getCookie("VDR-Live-Recordings-Tree-Open-Nodes");
//  isyslog("live: VDR-Live-Recordings-Tree-Open-Nodes = %s", openTreeNodes.c_str());
}
cToSvConcat<0> recording_item;
recording_item.reserve(25000);

#if TNTVERSION >= 30000
const char *TNT_ARRAY = "[]";
#else
const char *TNT_ARRAY = "";
#endif


  // <& pageelems.doc_type ...
  { 
#line 129 "recordings.ecpp"
    tnt::QueryParams _tnt_cq0;
#line 129 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "doc_type"), request, reply, _tnt_cq0);
    // &>
  }
  reply.out() << _tntChunks[3]; // \n<html>\n  <head>\n    <meta name="viewport" content="width=device-width, initial-scale=1" />\n    <title>VDR-Live - 
#line 133 "recordings.ecpp"
  reply.sout() << ( pageTitle );
  reply.out() << _tntChunks[4]; // </title>\n    
  // <& pageelems.stylesheets ...
  { 
#line 134 "recordings.ecpp"
    tnt::QueryParams _tnt_cq1;
#line 134 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "stylesheets"), request, reply, _tnt_cq1);
    // &>
  }
  reply.out() << _tntChunks[5]; // \n    
  // <& pageelems.create_html_js ...
  { 
#line 135 "recordings.ecpp"
    tnt::QueryParams _tnt_cq2;
#line 135 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "create_html_js"), request, reply, _tnt_cq2);
    // &>
  }
  reply.out() << _tntChunks[6]; // \n    
  // <& pageelems.ajax_js ...
  { 
#line 136 "recordings.ecpp"
    tnt::QueryParams _tnt_cq3;
#line 136 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_js"), request, reply, _tnt_cq3);
    // &>
  }
  reply.out() << _tntChunks[7]; // \n<script>\nconst recordings_tree_creation = 
#line 138 "recordings.ecpp"
  reply.sout() << ( cToSvInt(recordingsTree->getCreationTimestamp() ) );
  reply.out() << _tntChunks[8]; // ;\nconst recs = [];\nconst rec_ids = Object.create(null)\nrec_ids["T"] = [1, 2]\n\n// Title is the title of the action (like "play in media player"), and will be html encoded here\nfunction RecordingActionS(s, id, A, Img, Title) {\n  s.a += '<a href="'\n  s.a += A\n  s.a += 'recording_'\n  s.a += id\n  s.a += '&sort=
#line 149 "recordings.ecpp"
  reply.sout() << (currentSort);
  reply.out() << _tntChunks[9]; // &filter=
#line 149 "recordings.ecpp"
  reply.sout() << (currentFilter);
  reply.out() << _tntChunks[10]; // &flat=
#line 149 "recordings.ecpp"
  reply.sout() << (currentFlat);
  reply.out() << _tntChunks[11]; // &history_num_back=
#line 149 "recordings.ecpp"
  reply.sout() << (history_num_back+1);
  reply.out() << _tntChunks[12]; // " title="'\n  addEncodeHtml(s, Title)\n  s.a += '"><img class="icon" src="
#line 151 "recordings.ecpp"
  reply.sout() << (LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[13]; // '\n  s.a += Img\n  s.a += '" /></a>'\n}\nfunction RecordingActionPlaylist(s, id) {\n  s.a += '<a class="hidden-xs" href="playlist.m3u\?recid=recording_'\n  s.a += id\n  s.a += '&sort=
#line 158 "recordings.ecpp"
  reply.sout() << (currentSort);
  reply.out() << _tntChunks[14]; // &filter=
#line 158 "recordings.ecpp"
  reply.sout() << (currentFilter);
  reply.out() << _tntChunks[15]; // &flat=
#line 158 "recordings.ecpp"
  reply.sout() << (currentFlat);
  reply.out() << _tntChunks[16]; // &history_num_back=
#line 158 "recordings.ecpp"
  reply.sout() << (history_num_back+1);
  reply.out() << _tntChunks[17]; // " title="
#line 158 "recordings.ecpp"
  reply.sout() << (tr("Stream this recording into media player."));
  reply.out() << _tntChunks[18]; // " download><img class="icon hidden-xs" src="
#line 158 "recordings.ecpp"
  reply.sout() << (LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[19]; // playlist.png" /></a>'\n}\n\n// do not html encode title! will be html encoded here\nfunction addEventRec_r(s, eventid, title, folder, shortText, description) {\n  var http_params = '&sort=
#line 163 "recordings.ecpp"
  reply.sout() << ( sort );
  reply.out() << _tntChunks[20]; // &filter='\n  http_params += encodeURIComponent('
#line 164 "recordings.ecpp"
  reply.sout() << ( filter );
  reply.out() << _tntChunks[21]; // ')\n  http_params += '&flat=
#line 165 "recordings.ecpp"
  reply.sout() << ( flat );
  reply.out() << _tntChunks[22]; // &history_num_back=
#line 165 "recordings.ecpp"
  reply.sout() << ( history_num_back+1 );
  reply.out() << _tntChunks[23]; // '\n  addEventRec(s, 'recording_', eventid, http_params, title, folder, shortText, description)\n}\n</script>\n<script type="text/javascript" src="js.html"></script>\n\n  <script type="text/javascript" src="js/live/treeview.js"></script>\n  <script>\n  const tv = new Treeview("
#line 173 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[24]; // minus.png", "
#line 173 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[25]; // plus.png", "
#line 173 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[26]; // folder_open.png", "
#line 173 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[27]; // folder_closed.png");\n  </script>\n</head>\n<body onload="adjustHeader()" onresize="adjustHeader()" onpageshow="clearCheckboxes(document.getElementById('form_recordings'))">\n  
  // <& pageelems.logo ...
  { 
#line 177 "recordings.ecpp"
    tnt::QueryParams _tnt_cq4;
#line 177 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "logo"), request, reply, _tnt_cq4);
    // &>
  }
  reply.out() << _tntChunks[28]; // \n
#line 178 "recordings.ecpp"

const char *active_r;
if (flat == "true") active_r = "recordings_flat";
else active_r = "recordings";

if (!deleteResult.empty()) {

  reply.out() << _tntChunks[29]; //   
  // <& menu ...
  { 
#line 185 "recordings.ecpp"
    tnt::QueryParams _tnt_cq5;
#line 185 "recordings.ecpp"
    _tnt_cq5.add( "active", (active_r));
#line 185 "recordings.ecpp"
    _tnt_cq5.add( "component", "recordings.delete_error");
#line 185 "recordings.ecpp"
    _tnt_cq5.add( "filter", (filter));
#line 185 "recordings.ecpp"
    callComp(tnt::Compident(std::string(), "menu"), request, reply, _tnt_cq5);
    // &>
  }
  reply.out() << _tntChunks[30]; // \n
#line 186 "recordings.ecpp"

} else {

  reply.out() << _tntChunks[31]; //   
  // <& menu ...
  { 
#line 189 "recordings.ecpp"
    tnt::QueryParams _tnt_cq6;
#line 189 "recordings.ecpp"
    _tnt_cq6.add( "active", (active_r));
#line 189 "recordings.ecpp"
    _tnt_cq6.add( "component", "recordings.sort_options");
#line 189 "recordings.ecpp"
    _tnt_cq6.add( "filter", (filter));
#line 189 "recordings.ecpp"
    callComp(tnt::Compident(std::string(), "menu"), request, reply, _tnt_cq6);
    // &>
  }
  reply.out() << _tntChunks[32]; // \n
#line 190 "recordings.ecpp"

}

  reply.out() << _tntChunks[33]; //   <div class="inhalt">\n    <div class="boxheader"><div><div>
#line 194 "recordings.ecpp"
  reply.sout() << ( std::string(tr("List of recordings")) + " (" + diskinfo + ")" );
  reply.out() << _tntChunks[34]; // </div></div></div>\n
#line 195 "recordings.ecpp"

    int rec_cnt;
    {
      LOCK_RECORDINGS_READ;
      rec_cnt = Recordings->Count();  // Access VDRs global cRecordings Recordings instance.
    }
    if (rec_cnt == 0) {

  reply.out() << _tntChunks[35]; //       
#line 203 "recordings.ecpp"
  reply.sout() << ( tr("No recordings found") );
  reply.out() << _tntChunks[36]; // \n
#line 204 "recordings.ecpp"

    } else {
      uintptr_t irecording_item = (uintptr_t)&recording_item;
      RecordingsItemDirPtr recItemRoot = recordingsTree->getRoot();
      uintptr_t iRecItemRoot = (uintptr_t)&recItemRoot;
      uintptr_t iRecordingsTree = (uintptr_t)&recordingsTree;
      uintptr_t iOpenTreeNodes = (uintptr_t)&openTreeNodes;
      uintptr_t iAvailable_recs = (uintptr_t)&available_recs;

  reply.out() << _tntChunks[37]; //       <form method="post" name="recordings" id="form_recordings" action="recordings.ecpp">\n        <div class="recordings">\n          <ul class="recordingslist" style="display: block;">\n            
  // <& recordings.recordings_item ...
  { 
#line 216 "recordings.ecpp"
    tnt::QueryParams _tnt_cq7;
#line 216 "recordings.ecpp"
    _tnt_cq7.add( "iAvailable_recs", (iAvailable_recs));
#line 216 "recordings.ecpp"
    _tnt_cq7.add( "iOpenTreeNodes", (iOpenTreeNodes));
#line 216 "recordings.ecpp"
    _tnt_cq7.add( "iRecItem", (iRecItemRoot));
#line 216 "recordings.ecpp"
    _tnt_cq7.add( "iRecordingsTree", (iRecordingsTree));
#line 216 "recordings.ecpp"
    _tnt_cq7.add( "irecording_item", (irecording_item));
#line 216 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "recordings", "recordings_item"), request, reply, _tnt_cq7);
    // &>
  }
  reply.out() << _tntChunks[38]; // \n          </ul>\n        </div>\n        <input type="hidden" name="sort" value="
#line 219 "recordings.ecpp"
  reply.sout() << ( currentSort );
  reply.out() << _tntChunks[39]; // ">\n        <input type="hidden" name="filter" value="
#line 220 "recordings.ecpp"
  reply.sout() << ( currentFilter );
  reply.out() << _tntChunks[40]; // ">\n        <input type="hidden" name="flat" value="
#line 221 "recordings.ecpp"
  reply.sout() << ( currentFlat );
  reply.out() << _tntChunks[41]; // ">\n        <input type="hidden" name="history_num_back" value="
#line 222 "recordings.ecpp"
  reply.sout() << ( history_num_back );
  reply.out() << _tntChunks[42]; // ">\n        <div class="withmargin hidden-xs">\n          <button class="red" type="submit">
#line 224 "recordings.ecpp"
  reply.sout() << ( tr("Delete selected") );
  reply.out() << _tntChunks[43]; // </button>\n
  reply.out() << _tntChunks[44]; // \n        </div>\n      </form>\n
#line 228 "recordings.ecpp"

    }
std::chrono::duration<double> timeNeeded = std::chrono::high_resolution_clock::now() - timeStart;
dsyslog("live, time recordings.ecpp: %f", timeNeeded.count());

  reply.out() << _tntChunks[45]; //   </div>\n</body>\n</html>\n
  // <%include> page_exit.eh
  reply.out() << _tntChunks[46]; // \n
#line 5 "page_exit.eh"

  spoint.commit();
} catch ( vdrlive::HtmlError const& ex ) {
  tnt::QueryParams param = qparam;
  param.add( "pageTitle", pageTitle );
  param.add( "errorMessage", ex.what() );
  callComp( "error", request, reply, param );
}

  // </%include>
  reply.out() << _tntChunks[47]; // \n
  reply.out() << _tntChunks[48]; // \n\n
  reply.out() << _tntChunks[95]; // \n
  reply.out() << _tntChunks[96]; // \n
  reply.out() << _tntChunks[131]; // \n
  reply.out() << _tntChunks[132]; // \n
  reply.out() << _tntChunks[134]; // \n
  reply.out() << _tntChunks[135]; // \n
  reply.out() << _tntChunks[144]; // \n
  reply.out() << _tntChunks[145]; // \n
  reply.out() << _tntChunks[154]; // \n
  reply.out() << _tntChunks[155]; // \n
  reply.out() << _tntChunks[174]; // \n\n
  reply.out() << _tntChunks[175]; // \n
  reply.out() << _tntChunks[192]; // \n
  reply.out() << _tntChunks[197]; // \n
  reply.out() << _tntChunks[198]; // \n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::recordings_item_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::recordings_item " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
uintptr_t iRecItem = qparam.get< uintptr_t >("iRecItem", ( 0));
uintptr_t irecording_item = qparam.get< uintptr_t >("irecording_item", ( 0));
uintptr_t iRecordingsTree = qparam.get< uintptr_t >("iRecordingsTree", ( 0));
uintptr_t iOpenTreeNodes = qparam.get< uintptr_t >("iOpenTreeNodes", ( 0));
uintptr_t iAvailable_recs = qparam.get< uintptr_t >("iAvailable_recs", ( 0));
std::string parentIdHash = qparam.get< std::string >("parentIdHash");
  // </%args>

#line 31 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 36 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 37 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 38 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 39 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
#line 249 "recordings.ecpp"

// define sort order, and reverse (for recordings)
// use current sort order and selected sort option for that
bool reverse = false;
eSortOrder sortOrder = eSortOrder::name; // default
if (currentSort.compare(0, 4,  "date"  , 4) == 0) sortOrder = eSortOrder::date;
if (currentSort.compare(0, 6,  "errors", 6) == 0) sortOrder = eSortOrder::errors;
if (currentSort.compare(0, 8,  "errorsdur", 8) == 0) sortOrder = eSortOrder::durationDeviation;
if (currentSort.compare(0, 10, "duplicates", 10) == 0) sortOrder = eSortOrder::duplicatesLanguage;
if (currentSort == "datedesc" || currentSort == "namedesc") reverse = true;
// get rec item of this (current) dir
RecordingsItemDirPtr recItemThisDir = *(static_cast<RecordingsItemDirPtr *>((void *)iRecItem) );
RecordingsTreePtr recordingsTree = *(static_cast<RecordingsTreePtr *>((void *)iRecordingsTree) );
cToSvConcat<0> *recording_item = static_cast<cToSvConcat<0> *>((void *)irecording_item );
std::string openTreeNodes= *(static_cast<std::string *>((void *)iOpenTreeNodes) );
std::vector<int> available_recs = *(static_cast<std::vector<int> *>((void *)iAvailable_recs) );
int level = recItemThisDir->Level();


std::vector<RecordingsItemRecPtr> recItems;
const std::vector<RecordingsItemRecPtr> *recItemsC = NULL;

// data for dirs, and loop over dirs
const std::vector<RecordingsItemDirPtr> *dirItems = recItemThisDir->getDirs();
std::vector<RecordingsItemDirPtr>::const_iterator dirIterS, dirIterE, dirIter;
int direction; // for dirs
if (currentFlat != "true") {
  if (currentSort != "duplicates") {
// list of subdirs
    if (!recItemThisDir->dirEntriesSorted() && currentSort == "namedesc") {
// reverse loop over subdirs
      dirIterS = dirItems->end();
      dirIterE = dirItems->begin();
      direction = 0;
    } else {
// forward loop over subdirs
      dirIterS = dirItems->begin();
      dirIterE = dirItems->end();
      direction = 1;
    }
    for (dirIter = dirIterS; dirIter != dirIterE; std::advance(dirIter, direction) ) {
      if(direction == 0) --dirIter;
// this is the loop over the subdirs
// each subdir is a node, which can be expanded (or not)
// each subdir has an identifier in <ul> tag: fldr_<$ idHash $>
      RecordingsItemDirPtr recItem = *dirIter;

      if (!recItem->matchesFilter(currentFilter)) continue;
      /* search trough directory for new recordings */
      bool newR = false;
      if ( LiveSetup().GetMarkNewRec() ) newR = recItem->checkNew();
// calculate idHash: uniquely defines this node
      cToSvXxHash32 idHash(cToSvConcat(parentIdHash, recItem->Name()));
      iRecItem = (uintptr_t)&recItem;
  
  reply.out() << _tntChunks[49]; //       <li class="recording">\n        <div class="recording_item" onclick = "tv.Toggle(this, 'fldr_
#line 305 "recordings.ecpp"
  reply.sout() << ( idHash );
  reply.out() << _tntChunks[50]; // ')">\n        <table><tr>\n          
#line 307 "recordings.ecpp"
 if(level > 0) { 
  reply.out() << _tntChunks[51]; //             <td class = "space">\n              <img src="img/transparent.png" width="
#line 309 "recordings.ecpp"
  reply.sout() << ( 16*level );
  reply.out() << _tntChunks[52]; // px" height="16px" />\n            </td>\n          
#line 311 "recordings.ecpp"
 } 
  reply.out() << _tntChunks[53]; //           <td class="space">\n            <img class="recording_expander" src="
#line 313 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[54]; // plus.png" />\n          </td><td class="space">\n            <img class="recording_folder" src="
#line 315 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[55]; // folder_closed.png" />\n          </td>\n
#line 317 "recordings.ecpp"
         if (!recItem->scraperImage().path.empty() ) {

  reply.out() << _tntChunks[56]; //             <td class = space>\n              <div class="thumb">\n                <img data-src="/tvscraper/
#line 320 "recordings.ecpp"
  reply.sout() << ( recItem->scraperImage().path );
  reply.out() << _tntChunks[57]; // "\n                  class="
#line 321 "recordings.ecpp"
  reply.sout() << ( recItem->scraperImage().width > recItem->scraperImage().height?"thumb":"thumbpt" );
  reply.out() << _tntChunks[58]; // "\n                />\n              </div>\n            </td>\n
#line 325 "recordings.ecpp"
         }

  reply.out() << _tntChunks[59]; //         <td class="recording_folder_name
#line 326 "recordings.ecpp"
  reply.sout() << ( (newR ? "_new" : "") );
  reply.out() << _tntChunks[60]; // ">\n          
#line 327 "recordings.ecpp"
  reply.sout() << ( recItem->Name() );
  reply.out() << _tntChunks[61]; // \n        </td></tr></table>\n        </div>\n        <ul id="fldr_
#line 330 "recordings.ecpp"
  reply.sout() << ( idHash );
  reply.out() << _tntChunks[62]; // " class="recordingslist" style="display: none;">\n          
  // <& recordings.recordings_item ...
  { 
#line 331 "recordings.ecpp"
    tnt::QueryParams _tnt_cq8;
#line 331 "recordings.ecpp"
    _tnt_cq8.add( "iAvailable_recs", (iAvailable_recs));
#line 331 "recordings.ecpp"
    _tnt_cq8.add( "iOpenTreeNodes", (iOpenTreeNodes));
#line 331 "recordings.ecpp"
    _tnt_cq8.add( "iRecItem", (iRecItem));
#line 331 "recordings.ecpp"
    _tnt_cq8.add( "iRecordingsTree", (iRecordingsTree));
#line 331 "recordings.ecpp"
    _tnt_cq8.add( "irecording_item", (irecording_item));
#line 331 "recordings.ecpp"
    _tnt_cq8.add( "parentIdHash", (idHash));
#line 331 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "recordings", "recordings_item"), request, reply, _tnt_cq8);
    // &>
  }
  reply.out() << _tntChunks[63]; // \n        </ul>\n      </li>\n      
#line 334 "recordings.ecpp"

    } // end of loop over subdirs
// now the items
    recItemsC = recItemThisDir->getRecordings(sortOrder);
    if (recItemThisDir->recEntriesSorted() ) reverse = false;
  } // end if (currentSort != "duplicates")
} else {
// here we prepare the items in case of a flat list, no folders
  if (currentSort != "duplicates") {
    recItems.clear();
    size_t max_items = 100;
    if (reverse) {
      reverse = false;
      std::vector<RecordingsItemRecPtr>::const_iterator recIterFirst = recordingsTree->allRecordings(sortOrder)->begin();
      std::vector<RecordingsItemRecPtr>::const_iterator recIterLast  = recordingsTree->allRecordings(sortOrder)->end();
      for (; recIterFirst != recIterLast;) {
        --recIterLast;
        RecordingsItemRecPtr recItem = *recIterLast;
        if (!recItem->matchesFilter(currentFilter)) continue;
        recItems.push_back(recItem);
        if (recItems.size() >= max_items) break;
      }
    } else {
      for (const RecordingsItemRecPtr &rPtr: *recordingsTree->allRecordings(sortOrder) ) {
        if (!rPtr->matchesFilter(currentFilter)) continue;
        recItems.push_back(rPtr);
        if (recItems.size() >= max_items) break;
      }
    }
    recItemsC = &recItems;
  } else {
    recItems.clear();
    addDuplicateRecordingsSd(recItems, recordingsTree);
    addDuplicateRecordingsLang(recItems, recordingsTree);
    addDuplicateRecordingsNoSd(recItems, recordingsTree);
    recItemsC = &recItems;
  }
}
// do we have to get/write the recording details?
// we have to, if currentFlat == true || level == 0 || this folder is open (cookie)
bool write_recs = level == 0 || currentFlat == "true";
if (!write_recs && recItemsC) {
// check: is this folder open (cookie)?
  auto equal_fldf = [parentIdHash](cSv f) { return f.length() > 5 && f.compare(5, std::string_view::npos, parentIdHash) == 0; };
  cSplit splitOpenTreeNodes(openTreeNodes, ',', eSplitDelimBeginEnd::optional);
  write_recs = std::find_if(splitOpenTreeNodes.begin(), splitOpenTreeNodes.end(), equal_fldf) != splitOpenTreeNodes.end();
}
if (write_recs && recItemsC) {
// in case of duplicates, and not flat, the recItemsC is not available
  
  reply.out() << _tntChunks[64]; // <script>\n  
#line 385 "recordings.ecpp"

  std::chrono::time_point<std::chrono::high_resolution_clock> timeStart_recs = std::chrono::high_resolution_clock::now();
  for (const RecordingsItemRecPtr &rPtr: *recItemsC) {
    recording_item->clear();
    rPtr->AppendAsJSArray(*recording_item);
  
  reply.out() << _tntChunks[65]; // recs[
#line 391 "recordings.ecpp"
  reply.sout() << (cSv(cToSvInt(rPtr->IdI())));
  reply.out() << _tntChunks[66]; // ]=[
#line 391 "recordings.ecpp"
  reply.out() << ( *recording_item );
  reply.out() << _tntChunks[67]; // ]\n  
#line 392 "recordings.ecpp"

  }
  std::chrono::duration<double> timeNeeded_recs = std::chrono::high_resolution_clock::now() - timeStart_recs;
  dsyslog("live, time recordings.ecpp recs lv 0: %f", timeNeeded_recs.count());
  
  reply.out() << _tntChunks[68]; // \n</script>\n  
#line 399 "recordings.ecpp"

}
if (currentSort != "duplicates" || currentFlat == "true") {
  if (recItemsC->empty() ) { 
  reply.out() << _tntChunks[69]; //     <script>\n      rec_ids["fldr_
#line 404 "recordings.ecpp"
  reply.sout() << ( parentIdHash );
  reply.out() << _tntChunks[70]; // "] = []\n    </script>\n  
#line 406 "recordings.ecpp"
 } else {
    bool first = true;
//    const char *displayFolder = currentFlat == "true"?"1":"0";
    const char *displayFolder = "1";
    recording_item->clear();
    RecordingsItemRec::AppendAsJSArray(*recording_item, recItemsC->begin(), recItemsC->end(), first, currentFilter, reverse);
    
  reply.out() << _tntChunks[71]; //       <script>\n
#line 414 "recordings.ecpp"
   if (level == 0) {

  reply.out() << _tntChunks[72]; //       document.write(rec_string_d([
#line 415 "recordings.ecpp"
  reply.sout() << (level);
  reply.out() << _tntChunks[73]; // , 
#line 415 "recordings.ecpp"
  reply.sout() << (displayFolder);
  reply.out() << _tntChunks[74]; // , [ 
#line 415 "recordings.ecpp"
  reply.out() << ( *recording_item );
  reply.out() << _tntChunks[75]; //  ]]))\n
#line 416 "recordings.ecpp"
   } else {

  reply.out() << _tntChunks[76]; //       rec_ids["fldr_
#line 417 "recordings.ecpp"
  reply.sout() << ( parentIdHash );
  reply.out() << _tntChunks[77]; // "] = [
#line 417 "recordings.ecpp"
  reply.sout() << (level);
  reply.out() << _tntChunks[78]; // , 
#line 417 "recordings.ecpp"
  reply.sout() << (displayFolder);
  reply.out() << _tntChunks[79]; // , [ 
#line 417 "recordings.ecpp"
  reply.out() << ( *recording_item );
  reply.out() << _tntChunks[80]; //  ]]\n
#line 418 "recordings.ecpp"
   }

  reply.out() << _tntChunks[81]; //       </script>\n    
#line 420 "recordings.ecpp"

  }
} else {
// duplicates
  for (int i = 0; i < 3; i++) {
    recItems.clear();
    std::string nodeName;
    if (i == 0) {
      addDuplicateRecordingsSd(recItems, recordingsTree);
      nodeName = tr("Duplicates identified by tvscraper");
    } else if (i == 1) {
      addDuplicateRecordingsLang(recItems, recordingsTree);
      nodeName = tr("Duplicates, with different languages");
    } else if (i == 2) {
      addDuplicateRecordingsNoSd(recItems, recordingsTree);
      nodeName = tr("Duplicates not identified by tvscraper");
    }
    if (!recItems.empty() ) {
      cToSvXxHash32 idHash(nodeName);
// do we have to get/write the recording details?
// check: is this folder open (cookie)?
      cSv idHash_sv = idHash;
      auto equal_fldf = [idHash_sv](cSv f) { return f.length() > 5 && f.compare(5, std::string_view::npos, idHash_sv) == 0; };
      cSplit splitOpenTreeNodes(openTreeNodes, ',', eSplitDelimBeginEnd::optional);
      if (std::find_if(splitOpenTreeNodes.begin(), splitOpenTreeNodes.end(), equal_fldf) != splitOpenTreeNodes.end()) {
        
  reply.out() << _tntChunks[82]; // <script>\n        
#line 447 "recordings.ecpp"

        for (const RecordingsItemRecPtr &rPtr: recItems) {
          recording_item->clear();
          rPtr->AppendAsJSArray(*recording_item);
          
  reply.out() << _tntChunks[83]; // recs[
#line 452 "recordings.ecpp"
  reply.sout() << (cSv(cToSvInt(rPtr->IdI())));
  reply.out() << _tntChunks[84]; // ]=[
#line 452 "recordings.ecpp"
  reply.out() << ( *recording_item );
  reply.out() << _tntChunks[85]; // ]\n
#line 453 "recordings.ecpp"
       }

  reply.out() << _tntChunks[86]; // </script>\n      
#line 455 "recordings.ecpp"

      }
      bool first = true;
      recording_item->clear();
      RecordingsItemRec::AppendAsJSArray(*recording_item, recItems.begin(), recItems.end(), first, currentFilter, false);
      
  reply.out() << _tntChunks[87]; //       <li class="recording">\n        <div class="recording_item" onclick = "tv.Toggle(this, 'fldr_
#line 462 "recordings.ecpp"
  reply.sout() << ( idHash );
  reply.out() << _tntChunks[88]; // ')">\n          <table><tr><td class="space">\n            <img class="recording_expander" src="
#line 464 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[89]; // plus.png" />\n          </td><td class="space">\n            <img class="recording_folder" src="
#line 466 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[90]; // folder_closed.png" />\n          </td><td class="recording_folder_name">\n            
#line 468 "recordings.ecpp"
  reply.sout() << ( nodeName );
  reply.out() << _tntChunks[91]; // \n          </td></tr></table>\n        </div>\n        <ul id="fldr_
#line 471 "recordings.ecpp"
  reply.sout() << ( idHash );
  reply.out() << _tntChunks[92]; // " class="recordingslist" style="display: none;">\n          <script>\n            rec_ids["fldr_
#line 473 "recordings.ecpp"
  reply.sout() << ( idHash );
  reply.out() << _tntChunks[93]; // "] = [1, 1, [ 
#line 473 "recordings.ecpp"
  reply.out() << ( *recording_item );
  reply.out() << _tntChunks[94]; //  ]]\n          </script>\n        </ul>\n      </li>\n      
#line 477 "recordings.ecpp"

    }
  }
}

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::sort_options_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::sort_options " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 31 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 36 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 37 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 38 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 39 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
#line 486 "recordings.ecpp"
 { 
  reply.out() << _tntChunks[97]; // <span class="label bold">
#line 487 "recordings.ecpp"
  reply.sout() << ( tr("Sort:") );
  reply.out() << _tntChunks[98]; //  </span>\n<a href="recordings.html\?sort=
#line 488 "recordings.ecpp"
  reply.sout() << ( (currentSort == "nameasc") ? "namedesc" : "nameasc");
  reply.out() << _tntChunks[99]; // &filter=
#line 488 "recordings.ecpp"
  if ( !currentFilter.empty() )
    reply.sout() <<  currentFilter ;
  reply.out() << _tntChunks[100]; // &flat=
#line 488 "recordings.ecpp"
  reply.sout() << (currentFlat);
  reply.out() << _tntChunks[101]; // " 
  // <& setactive ...
  { 
#line 488 "recordings.ecpp"
    tnt::QueryParams _tnt_cq9;
#line 488 "recordings.ecpp"
    _tnt_cq9.add( "current", "name");
#line 488 "recordings.ecpp"
  main().setactive(request, reply, _tnt_cq9);
    // &>
  }
  reply.out() << _tntChunks[102]; //  >
#line 488 "recordings.ecpp"
  reply.sout() << ( tr("Name") );
  reply.out() << _tntChunks[103]; // </a>\n<span class="sep">|</span>\n<a href="recordings.html\?sort=
#line 490 "recordings.ecpp"
  reply.sout() << ( (currentSort == "datedesc") ? "dateasc" : "datedesc");
  reply.out() << _tntChunks[104]; // &filter=
#line 490 "recordings.ecpp"
  if ( !currentFilter.empty() )
    reply.sout() <<  currentFilter ;
  reply.out() << _tntChunks[105]; // &flat=
#line 490 "recordings.ecpp"
  reply.sout() << (currentFlat);
  reply.out() << _tntChunks[106]; // " 
  // <& setactive ...
  { 
#line 490 "recordings.ecpp"
    tnt::QueryParams _tnt_cq10;
#line 490 "recordings.ecpp"
    _tnt_cq10.add( "current", "date");
#line 490 "recordings.ecpp"
  main().setactive(request, reply, _tnt_cq10);
    // &>
  }
  reply.out() << _tntChunks[107]; //  >
#line 490 "recordings.ecpp"
  reply.sout() << ( tr("Date") );
  reply.out() << _tntChunks[108]; // </a>\n<span class="sep">|</span>\n<a href="recordings.html\?sort=duplicates&filter=
#line 492 "recordings.ecpp"
  if ( !currentFilter.empty() )
    reply.sout() <<  currentFilter ;
  reply.out() << _tntChunks[109]; // &flat=
#line 492 "recordings.ecpp"
  reply.sout() << (currentFlat);
  reply.out() << _tntChunks[110]; // " 
  // <& setactive ...
  { 
#line 492 "recordings.ecpp"
    tnt::QueryParams _tnt_cq11;
#line 492 "recordings.ecpp"
    _tnt_cq11.add( "current", "duplicates");
#line 492 "recordings.ecpp"
  main().setactive(request, reply, _tnt_cq11);
    // &>
  }
  reply.out() << _tntChunks[111]; //  >
#line 492 "recordings.ecpp"
  reply.sout() << ( tr("Duplicates") );
  reply.out() << _tntChunks[112]; // </a>\n
#line 493 "recordings.ecpp"

#if VDRVERSNUM >= 20505

  reply.out() << _tntChunks[113]; // <span class="sep">|</span>\n<a href="recordings.html\?sort=
#line 497 "recordings.ecpp"
  reply.sout() << ( (currentSort == "errorsts") ? "errorsdur" : "errorsts" );
  reply.out() << _tntChunks[114]; // &filter=
#line 497 "recordings.ecpp"
  if ( !currentFilter.empty() )
    reply.sout() <<  currentFilter ;
  reply.out() << _tntChunks[115]; // &flat=
#line 497 "recordings.ecpp"
  reply.sout() << (currentFlat);
  reply.out() << _tntChunks[116]; // " 
  // <& setactive ...
  { 
#line 497 "recordings.ecpp"
    tnt::QueryParams _tnt_cq12;
#line 497 "recordings.ecpp"
    _tnt_cq12.add( "current", "errors");
#line 497 "recordings.ecpp"
  main().setactive(request, reply, _tnt_cq12);
    // &>
  }
  reply.out() << _tntChunks[117]; // >
#line 497 "recordings.ecpp"
  reply.sout() << ( tr("Errors") );
  reply.out() << _tntChunks[118]; // </a>\n
#line 498 "recordings.ecpp"

#endif

  reply.out() << _tntChunks[119]; // <span class="sep">|</span>\n<span class="label bold">
#line 502 "recordings.ecpp"
  reply.sout() << ( tr("Filter") );
  reply.out() << _tntChunks[120]; // :&nbsp;<input type="text" name="filter" value="
#line 502 "recordings.ecpp"
  reply.sout() << ( currentFilter );
  reply.out() << _tntChunks[121]; // " id="filter" onchange="filterRecordings(this, '
#line 502 "recordings.ecpp"
  reply.sout() << ( currentSort );
  reply.out() << _tntChunks[122]; // ', '
#line 502 "recordings.ecpp"
  reply.sout() << (currentFlat);
  reply.out() << _tntChunks[123]; // ')" />&nbsp;
  // <& tooltip.help ...
  { 
#line 502 "recordings.ecpp"
    tnt::QueryParams _tnt_cq13;
#line 502 "recordings.ecpp"
    _tnt_cq13.add( "text", (tr("Look in recordings titles and subtitles for the given string and display only the matching ones. You may also use perl compatible regular expressions (PCRE).")));
#line 502 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "help"), request, reply, _tnt_cq13);
    // &>
  }
  reply.out() << _tntChunks[124]; // </span>\n
#line 503 "recordings.ecpp"

if (currentFlat != "true") {

  reply.out() << _tntChunks[125]; // <span class="sep">|</span>\n<img onclick="ExpandAll()" src="
#line 507 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "plus.png") );
  reply.out() << _tntChunks[126]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 507 "recordings.ecpp"
    tnt::QueryParams _tnt_cq14;
#line 507 "recordings.ecpp"
    _tnt_cq14.add( "text", (tr("Expand all folders")));
#line 507 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq14);
    // &>
  }
  reply.out() << _tntChunks[127]; // />\n<img onclick="CollapseAll()" src="
#line 508 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "minus.png") );
  reply.out() << _tntChunks[128]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 508 "recordings.ecpp"
    tnt::QueryParams _tnt_cq15;
#line 508 "recordings.ecpp"
    _tnt_cq15.add( "text", (tr("Collapse all folders")));
#line 508 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq15);
    // &>
  }
  reply.out() << _tntChunks[129]; // />\n
#line 509 "recordings.ecpp"

}

  reply.out() << _tntChunks[130]; // <br />\n
#line 513 "recordings.ecpp"
 } 
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::setactive_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::setactive " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string current = qparam.get< std::string >("current");
  // </%args>

#line 31 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 36 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 37 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 38 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 39 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
#line 521 "recordings.ecpp"

if (currentSort.compare(0, current.length(), current) == 0) { 
  reply.out() << _tntChunks[133]; // class="active"
#line 522 "recordings.ecpp"
 } 
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::del_rec_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::del_rec " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string id = qparam.get< std::string >("id");
std::string sort = qparam.get< std::string >("sort");
std::string filter = qparam.get< std::string >("filter");
std::string flat = qparam.get< std::string >("flat");
int history_num_back = qparam.get< int >("history_num_back", ( 0));
  // </%args>

#line 31 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 36 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 37 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 38 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 39 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
#line 534 "recordings.ecpp"
 { 
  reply.out() << _tntChunks[136]; // <a href="epginfo.html\?epgid=del_
#line 534 "recordings.ecpp"
  reply.sout() << ( id );
  reply.out() << _tntChunks[137]; // &sort=
#line 534 "recordings.ecpp"
  reply.sout() << (sort);
  reply.out() << _tntChunks[138]; // &filter=
#line 534 "recordings.ecpp"
  reply.sout() << (filter);
  reply.out() << _tntChunks[139]; // &flat=
#line 534 "recordings.ecpp"
  reply.sout() << (flat);
  reply.out() << _tntChunks[140]; // &history_num_back=
#line 534 "recordings.ecpp"
  reply.sout() << (history_num_back+1);
  reply.out() << _tntChunks[141]; // " 
  // <& tooltip.hint ...
  { 
#line 534 "recordings.ecpp"
    tnt::QueryParams _tnt_cq16;
#line 534 "recordings.ecpp"
    _tnt_cq16.add( "text", (tr("Delete this recording from hard disc!")));
#line 534 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq16);
    // &>
  }
  reply.out() << _tntChunks[142]; // ><img src="
#line 534 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "del.png") );
  reply.out() << _tntChunks[143]; // " alt="" /></a>
#line 534 "recordings.ecpp"
 } 
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::edit_rec_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::edit_rec " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string id = qparam.get< std::string >("id");
std::string sort = qparam.get< std::string >("sort");
std::string filter = qparam.get< std::string >("filter");
std::string flat = qparam.get< std::string >("flat");
int history_num_back = qparam.get< int >("history_num_back", ( 0));
  // </%args>

#line 31 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 36 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 37 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 38 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 39 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
#line 546 "recordings.ecpp"
 { 
  reply.out() << _tntChunks[146]; // <a href="edit_recording.html\?recid=
#line 546 "recordings.ecpp"
  reply.sout() << ( id );
  reply.out() << _tntChunks[147]; // &sort=
#line 546 "recordings.ecpp"
  reply.sout() << (sort);
  reply.out() << _tntChunks[148]; // &filter=
#line 546 "recordings.ecpp"
  reply.sout() << (filter);
  reply.out() << _tntChunks[149]; // &flat=
#line 546 "recordings.ecpp"
  reply.sout() << (flat);
  reply.out() << _tntChunks[150]; // &history_num_back=
#line 546 "recordings.ecpp"
  reply.sout() << (history_num_back+1);
  reply.out() << _tntChunks[151]; // "><img src="
#line 546 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "edit.png") );
  reply.out() << _tntChunks[152]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 546 "recordings.ecpp"
    tnt::QueryParams _tnt_cq17;
#line 546 "recordings.ecpp"
    _tnt_cq17.add( "text", (tr("Edit recording")));
#line 546 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq17);
    // &>
  }
  reply.out() << _tntChunks[153]; //  /></a>
#line 546 "recordings.ecpp"
 } 
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::todel_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::todel " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string todel = qparam.get< std::string >("todel");
std::string confirmed = qparam.get< std::string >("confirmed");
std::string history_num_back = qparam.get< std::string >("history_num_back");
  // </%args>

#line 31 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 36 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 37 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 38 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 39 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
#line 556 "recordings.ecpp"

  std::string recording_Name;
  {
    LOCK_RECORDINGS_READ;
    const cRecording *recording = RecordingsManager::GetByHash(todel, Recordings);
    if (recording == nullptr)
      throw HtmlError(tr("Couldn't find recording or no recordings available"));
    recording_Name = recording->Name();
  }
  if (!cUser::CurrentUserHasRightTo(UR_DELRECS))
    throw HtmlError( tr("Sorry, no permission. Please contact your administrator!") );
  if (confirmed == "confirmed") {
    RecordingsManager::DeleteRecording(todel);

  reply.out() << _tntChunks[156]; // <!DOCTYPE html>\n<html>\n  <script>\n    history.go(-
#line 573 "recordings.ecpp"
  reply.sout() << ( history_num_back );
  reply.out() << _tntChunks[157]; // );\n  </script>\n</html>\n
#line 576 "recordings.ecpp"
  } else {

  reply.out() << _tntChunks[158]; // <div class="epg_description" id="del_
#line 577 "recordings.ecpp"
  reply.sout() << ( todel );
  reply.out() << _tntChunks[159]; // ">\n  <div class="station">\n    <div class="boxheader"><div><div class="caption">
#line 579 "recordings.ecpp"
  reply.sout() << ( tr("Delete recordings") );
  reply.out() << _tntChunks[160]; // </div></div></div>\n  </div>\n  <div class="epg_content">\n    <form>\n      <div class="about_head"><div><div>
#line 583 "recordings.ecpp"
  reply.sout() << ( cToSvFormated(tr("Delete recording \"%s\"?"), recording_Name.empty()?"No recording name available":recording_Name.c_str() ) );
  reply.out() << _tntChunks[161]; // </div></div></div>\n      <input type="hidden" name="epgid" value="
#line 584 "recordings.ecpp"
  reply.sout() << (todel);
  reply.out() << _tntChunks[162]; // " >\n      <input type="hidden" name="delete_rec" value="confirmed" >\n      <input type="hidden" name="history_num_back" value="
#line 586 "recordings.ecpp"
  reply.sout() << ( history_num_back );
  reply.out() << _tntChunks[163]; // " id="history_del_
#line 586 "recordings.ecpp"
  reply.sout() << ( todel );
  reply.out() << _tntChunks[164]; // ">\n      <div class="about_left">\n        <button id="confirm_del_
#line 588 "recordings.ecpp"
  reply.sout() << ( todel );
  reply.out() << _tntChunks[165]; // " class="green" type="button" onclick="delete_rec_back('
#line 588 "recordings.ecpp"
  reply.sout() << ( todel );
  reply.out() << _tntChunks[166]; // ', 
#line 588 "recordings.ecpp"
  reply.sout() << ( history_num_back );
  reply.out() << _tntChunks[167]; // )">
#line 588 "recordings.ecpp"
  reply.sout() << ( tr("Delete"));
  reply.out() << _tntChunks[168]; // </button>\n      </div>\n      <div class="about_right">\n
  reply.out() << _tntChunks[169]; // \n<script>\nfunction cancel_delete() {\n  if (document.referrer.indexOf("epginfo.html\?") != -1) {\n    history.go(-1);\n  } else {\n    history.go(-
#line 597 "recordings.ecpp"
  reply.sout() << ( history_num_back );
  reply.out() << _tntChunks[170]; // );\n  }\n}\n</script>\n        <button id="close_del_
#line 601 "recordings.ecpp"
  reply.sout() << ( todel );
  reply.out() << _tntChunks[171]; // " type="button" class="red" onclick="back_depending_referrer(1, 
#line 601 "recordings.ecpp"
  reply.sout() << (history_num_back );
  reply.out() << _tntChunks[172]; // )">
#line 601 "recordings.ecpp"
  reply.sout() << ( tr("Cancel") );
  reply.out() << _tntChunks[173]; // </button>\n      </div>\n    </form>\n  </div>\n</div>\n
#line 606 "recordings.ecpp"
 }

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::rec_tools_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::rec_tools " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string id = qparam.get< std::string >("id");
std::string title = qparam.get< std::string >("title");
std::string s_IMDB_ID = qparam.get< std::string >("s_IMDB_ID");
std::string sort = qparam.get< std::string >("sort");
std::string filter = qparam.get< std::string >("filter");
std::string flat = qparam.get< std::string >("flat");
int history_num_back = qparam.get< int >("history_num_back", ( 0));
  // </%args>

#line 31 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 36 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 37 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 38 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 39 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
#line 621 "recordings.ecpp"
   if (cDevice::PrimaryDevice() && cDevice::PrimaryDevice()->HasDecoder() ) {

  // <& pageelems.ajax_action_href ...
  { 
#line 622 "recordings.ecpp"
    tnt::QueryParams _tnt_cq18;
#line 622 "recordings.ecpp"
    _tnt_cq18.add( "action", "play_recording");
#line 622 "recordings.ecpp"
    _tnt_cq18.add( "alt", "");
#line 622 "recordings.ecpp"
    _tnt_cq18.add( "image", "play.png");
#line 622 "recordings.ecpp"
    _tnt_cq18.add( "param", (id));
#line 622 "recordings.ecpp"
    _tnt_cq18.add( "tip", (tr("play this recording")));
#line 622 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_action_href"), request, reply, _tnt_cq18);
    // &>
  }
  reply.out() << _tntChunks[176]; // \n
#line 623 "recordings.ecpp"
   }

  // <& pageelems.hls_recording ...
  { 
#line 624 "recordings.ecpp"
    tnt::QueryParams _tnt_cq19;
#line 624 "recordings.ecpp"
    _tnt_cq19.add( "recId", (id));
#line 624 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "hls_recording"), request, reply, _tnt_cq19);
    // &>
  }
  reply.out() << _tntChunks[177]; // \n
  // <& pageelems.m3u_playlist_recording ...
  { 
#line 625 "recordings.ecpp"
    tnt::QueryParams _tnt_cq20;
#line 625 "recordings.ecpp"
    _tnt_cq20.add( "recid", (id));
#line 625 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "m3u_playlist_recording"), request, reply, _tnt_cq20);
    // &>
  }
  reply.out() << _tntChunks[178]; // \n
  // <& pageelems.imdb_info_href ...
  { 
#line 626 "recordings.ecpp"
    tnt::QueryParams _tnt_cq21;
#line 626 "recordings.ecpp"
    _tnt_cq21.add( "s_IMDB_ID", (s_IMDB_ID));
#line 626 "recordings.ecpp"
    _tnt_cq21.add( "title", (title));
#line 626 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "imdb_info_href"), request, reply, _tnt_cq21);
    // &>
  }
  reply.out() << _tntChunks[179]; // \n
  // <& recordings.edit_rec ...
  { 
#line 627 "recordings.ecpp"
    tnt::QueryParams _tnt_cq22;
#line 627 "recordings.ecpp"
    _tnt_cq22.add( "filter", (filter));
#line 627 "recordings.ecpp"
    _tnt_cq22.add( "flat", (flat));
#line 627 "recordings.ecpp"
    _tnt_cq22.add( "history_num_back", (history_num_back));
#line 627 "recordings.ecpp"
    _tnt_cq22.add( "id", (id));
#line 627 "recordings.ecpp"
    _tnt_cq22.add( "sort", (sort));
#line 627 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "recordings", "edit_rec"), request, reply, _tnt_cq22);
    // &>
  }
  reply.out() << _tntChunks[180]; // \n
  // <& recordings.del_rec ...
  { 
#line 628 "recordings.ecpp"
    tnt::QueryParams _tnt_cq23;
#line 628 "recordings.ecpp"
    _tnt_cq23.add( "filter", (filter));
#line 628 "recordings.ecpp"
    _tnt_cq23.add( "flat", (flat));
#line 628 "recordings.ecpp"
    _tnt_cq23.add( "history_num_back", (history_num_back));
#line 628 "recordings.ecpp"
    _tnt_cq23.add( "id", (id));
#line 628 "recordings.ecpp"
    _tnt_cq23.add( "sort", (sort));
#line 628 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "recordings", "del_rec"), request, reply, _tnt_cq23);
    // &>
  }
  reply.out() << _tntChunks[181]; // \n
#line 629 "recordings.ecpp"

const RecordingsItemRecPtr recPtr = RecordingsManager::GetByIdHash(id);
if (recPtr && recPtr->scraperDataAvailable() ) {
  const char *sdhd = nullptr;
  cToSvConcat frameParams;
  StringAppendFrameParams(frameParams, recPtr.get() );
  switch (recPtr->FrameWidth()) {
    case 720:
      sdhd = "720x576";
      break;
    case 1280:
      sdhd = "1280x720";
      break;
    case 1920:
      sdhd = "1920x1080";
      break;
    case 3840:
      sdhd = "3840x2160";
      break;
    default:
      break;
  }
  int video_SD_HD = recPtr->SD_HD();
  if (!sdhd) sdhd = video_SD_HD == 0 ? "sd": video_SD_HD == 1 ? "hd": "ud";
  cToSvConcat duration;
  AppendDuration(duration, tr("%d:%02d"), recPtr->Duration() );

  reply.out() << _tntChunks[182]; // <img data-src="img/transparent.png" height="10px" />\n<span id="icons-
#line 657 "recordings.ecpp"
  reply.sout() << (id);
  reply.out() << _tntChunks[183]; // "></span>\n<script class="injectIcons">\ninjectErrorHdSdIcon("icons-
#line 659 "recordings.ecpp"
  reply.sout() << (id);
  reply.out() << _tntChunks[184]; // ", 
#line 659 "recordings.ecpp"
  reply.sout() << (cToSvInt(recPtr->RecordingErrors()));
  reply.out() << _tntChunks[185]; // , 
#line 659 "recordings.ecpp"
  reply.sout() << (cToSvInt(recPtr->DurationDeviation()));
  reply.out() << _tntChunks[186]; // , "
#line 659 "recordings.ecpp"
  reply.sout() << (sdhd);
  reply.out() << _tntChunks[187]; // ", "
#line 659 "recordings.ecpp"
  reply.sout() << (recPtr->ChannelName());
  reply.out() << _tntChunks[188]; // ", "
#line 659 "recordings.ecpp"
  reply.sout() << (duration);
  reply.out() << _tntChunks[189]; // ", 
#line 659 "recordings.ecpp"
  reply.sout() << ( cToSvInt(recPtr->NumberTsFiles()) );
  reply.out() << _tntChunks[190]; // , "
#line 659 "recordings.ecpp"
  reply.sout() << (frameParams);
  reply.out() << _tntChunks[191]; // ")\n</script>\n
#line 661 "recordings.ecpp"

}

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::archived_disc_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::archived_disc " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string archived = qparam.get< std::string >("archived");
std::string title = qparam.get< std::string >("title");
std::string s_IMDB_ID = qparam.get< std::string >("s_IMDB_ID");
  // </%args>

#line 31 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 36 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 37 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 38 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 39 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  reply.out() << _tntChunks[193]; // <img src="
#line 672 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "on_dvd.png") );
  reply.out() << _tntChunks[194]; // " alt="on_dvd" 
  // <& tooltip.hint ...
  { 
#line 672 "recordings.ecpp"
    tnt::QueryParams _tnt_cq24;
#line 672 "recordings.ecpp"
    _tnt_cq24.add( "text", (archived));
#line 672 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq24);
    // &>
  }
  reply.out() << _tntChunks[195]; //  />\n
  // <& pageelems.imdb_info_href ...
  { 
#line 673 "recordings.ecpp"
    tnt::QueryParams _tnt_cq25;
#line 673 "recordings.ecpp"
    _tnt_cq25.add( "s_IMDB_ID", (s_IMDB_ID));
#line 673 "recordings.ecpp"
    _tnt_cq25.add( "title", (title));
#line 673 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "imdb_info_href"), request, reply, _tnt_cq25);
    // &>
  }
  reply.out() << _tntChunks[196]; // \n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::delete_error_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::delete_error " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 31 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 36 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 37 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 38 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 39 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  // <& recordings.sort_options ...
  { 
#line 678 "recordings.ecpp"
    tnt::QueryParams _tnt_cq26;
#line 678 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "recordings", "sort_options"), request, reply, _tnt_cq26);
    // &>
  }
  reply.out() << _tntChunks[199]; // \n
#line 679 "recordings.ecpp"
 { reply.out() << deleteResult; } 
  // <%/cpp>
  return DEFAULT;
}

} // namespace
